// qtest.c++

// #include "Parse/Parse.h++"
#include "QuickMath/QuickMath.h++"

static int verbose = 0;

int
main( int argc, char *argv[] )
{
//     ParseRuleFlag( 'v', verbose, 1, "Verbose mode" );
//     
//     if( Parse::ParseCmdLine( argc, argv ) )
//        Parse::Usage( argv[0] ), exit(1);
// 
    static real q1data[4] = { 0.2220, 0.0477, 0.6884, 0.6888 };
    static real q2data[4] = { 0.6641, 0.2725, 0.3690, 0.5904 };

    qmUnitQuaternionRef q1( q1data );
    qmUnitQuaternionRef q2( q2data );
    qmUnitQuaternion qm;

    qmMatrix R1( 3, 3 );
    qmMatrix R2( 3, 3 );
    qmMatrix Rm( 3, 3 );
    qmMatrix R12( 3, 3 );
    qmMatrix R21( 3, 3 );

    qm.setMultiply( q1, q2 );
    q1.getRotationMatrix( R1 );
    q2.getRotationMatrix( R2 );
    qm.getRotationMatrix( Rm );

    R12.setMultiply( R1, R2 );
    R21.setMultiply( R2, R1 );

    cout << "q1= " << q1 << endl;
    cout << "q2= " << q2 << endl;
    cout << "qm= " << qm << endl;

    cout << "R1= " << R1 << endl;
    cout << "R2= " << R2 << endl;
    cout << "Rm= " << Rm << endl;

    cout << "R12= " << R12 << endl;
    cout << "R21= " << R21 << endl;

    qmUnitQuaternion qR1;
    qmUnitQuaternion qR2;

    cout << "qR1= " << qR1 << endl;
    cout << "qR2= " << qR2 << endl;

    qR1.set( R1 );
    qR2.set( R2 );

    cout << "qR1= " << qR1 << endl;
    cout << "qR2= " << qR2 << endl;

    return 0;
}
