// qmMatrix.h++

#ifndef _qmMatrix_H_
#define _qmMatrix_H_

#include <stddef.h>
#include <iostream.h>
#include <assert.h>
#include "qmReal.h"
#include "qmMatrixRef.h"

class qmMatrix : public qmMatrixRef
{
    real *allocArray;
public:
    qmMatrix( )
      : qmMatrixRef( ), allocArray( 0 ) {}
    qmMatrix( int h, int w );
    qmMatrix( int h, int w, real *data );
    qmMatrix( const qmMatrix& m );
    qmMatrix( const qmMatrixRef& m );
    qmMatrix& set( int h, int w );
    qmMatrix& set( int h, int w, real *data );
    qmMatrix& set( const qmMatrixRef& m );
    qmMatrix& operator=( const qmMatrixRef& qm ) { return set( qm ); }
    virtual ~qmMatrix() { if( allocArray) delete [] allocArray; }
};

#endif /* _qmMatrix_H_ */


