// qmUnitQuaternionRef.h++

#ifndef _qmUnitQuaternionRef_H_
#define _qmUnitQuaternionRef_H_

#include "qmVectorRef.h"
#include "qmMatrixRef.h"

class qmUnitQuaternionRef : public qmVectorRef
{
public:
    qmUnitQuaternionRef()
      : qmVectorRef() {}
    qmUnitQuaternionRef( real *rp )
      : qmVectorRef( 4, rp ) {}
    qmUnitQuaternionRef& set( real* rp );
    qmMatrixRef& getRotationMatrix( qmMatrixRef& out ) const;
    qmUnitQuaternionRef& setIdentity();
    qmUnitQuaternionRef& setMultiply( const qmUnitQuaternionRef&, 
				      const qmUnitQuaternionRef& );
    qmUnitQuaternionRef& setNormal();
    qmUnitQuaternionRef& setInvert( const qmUnitQuaternionRef& );
    inline qmUnitQuaternionRef& operator=( const qmUnitQuaternionRef& );
    qmUnitQuaternionRef& setAddAngles( const qmUnitQuaternionRef&,
				       const qmVectorRef& angles );
    real getAngle();
    qmUnitQuaternionRef& setSubtract( const qmUnitQuaternionRef&,
				      const qmUnitQuaternionRef& );
    qmUnitQuaternionRef& set( const qmMatrixRef& );
};

inline
qmUnitQuaternionRef&
qmUnitQuaternionRef::operator=( const qmUnitQuaternionRef& uq )
{
    qmVectorRef::set( uq );
    return *this;
}

typedef qmUnitQuaternionRef qmQuatRef;

#endif /* _qmUnitQuaternionRef_H_ */
