// qmdArray.h++

#ifndef _qmdArray_H_
#define _qmdArray_H_

#include "qmdArrayRef.h"

template < class TRef_ >
class qmdArray : public qmdArrayRef<TRef_>
{
    void* allocMem;
 public:
    qmdArray()
      : qmdArrayRef<TRef_>(), allocMem( 0 ) {}
    qmdArray( TRef_& r, int n )
      : qmdArrayRef<TRef_>(), allocMem( 0 ) { set( r, n ); }
    ~qmdArray() { if( allocMem ) delete []  allocMem; }
    void set( TRef_&, int );
};

template < class TRef_ >
void
qmdArray<TRef_>::set( TRef_& tr, int n )
{
    if( allocMem )
       delete [] allocMem;
    qmdArrayRef<TRef_>::set( tr, n, 0 );
    allocMem = new char*[ getByteCount() ];
    referTo( allocMem );
}

#endif /* _qmdArray_H_ */
