// qmdArrayRef.h++

#ifndef _qmdArrayRef_H_
#define _qmdArrayRef_H_

// class TRef_
// {
//   public:
//	TRef_& referTo( void* p );
//	int getByteCount();
// }
//
// ostream& operator<<( ostream&, const TRef_& );
// istream& operator>>( istream&, TRef_& );

template < class TRef_ >
class qmdArrayRef
{
    TRef_ ref;
    int size;
    int count;
    void* mem;

public:
    qmdArrayRef()
      : ref(), mem(0), size(0), count(0) {}
    qmdArrayRef( TRef_& r, int n, void* p )
      : ref(), mem(0), size(0), count(0) { set( r, n, p ); }
    void set( TRef_&, int, void* );
    inline TRef_& operator[]( int );
    inline const TRef_& get( int ) const;
    qmdArrayRef<TRef_>& referTo( void* p ) { mem = p; return *this; }
    int getByteCount() { return( count*size ); }
    ostream& print( ostream& ) const;
};

template < class TRef_ >
void
qmdArrayRef<TRef_>::set( TRef_& tr, int n, void* p )
{
    count = n;
    size = tr.getByteCount();
    mem = p;
    ref = tr;
    ref.referTo( mem );
}

template < class TRef_ >
inline
TRef_&
qmdArrayRef<TRef_>::operator[]( int i )
{ 
    return ref.referTo( ((char*)mem) + i * size );
}

template < class TRef_ >
inline
const TRef_&
qmdArrayRef<TRef_>::get( int i ) const
{
    TRef_ tmp = ref;
    return tmp.referTo( ((char*)mem) + i * size );
}

template < class TRef_ >
ostream&
qmdArrayRef<TRef_>::print( ostream& os ) const
{
    for( int i = 0; i < count; i++ )
       os << get(i) << endl;
    return os;
}

template < class TRef_ >
ostream&
operator<<( ostream& os, const qmdArrayRef<TRef_>& ar )
{
    return ar.print( os );
}

#endif /* _qmdArrayRef_H_ */
