// qmdLUDecomposition.h++

#ifndef _qmdLUDecomposition_H_
#define _qmdLUDecomposition_H_

#include <iostream.h>
#include "qmdMatrix.h"
#include "qmdVector.h"

class qmdLUDecomposition
{
    qmdMatrix LUmatrix;
    int* rowOrder;

private:

    static int findMaxPivot( qmdMatrixRef&, int col, int *rowOrder );
    static void forwardSubstitute( qmdMatrixRef& LU, 
				   int *rowOrder,
				   reald *b,
				   reald *y );
    static void backwardSubstitute( qmdMatrixRef& LU, 
				    int *rowOrder,
				    reald *y,
				    reald *x );

public:

    qmdLUDecomposition() 
      : LUmatrix(), rowOrder(0) {}
    qmdLUDecomposition( const qmdMatrixRef& m )
      : LUmatrix(), rowOrder(0) { set( m ); }
    int set( const qmdMatrixRef& );
    qmdMatrixRef& getLU() { return LUmatrix; }
    int* getRowOrder() { return rowOrder; }
    static int LUDecompose( qmdMatrixRef& A, int* rorder );
    static int LUSolve( qmdMatrixRef& LU, 
			int* rorder,
			qmdVectorRef& y,
			qmdVectorRef& x );
    static int LUInvert( qmdMatrixRef& LU, int* rorder, qmdMatrixRef& Ai );
    int solve( qmdVectorRef& y, qmdVectorRef& x );
    int invert( qmdMatrixRef& Ai );
    ostream& print( ostream& );
};

typedef qmdLUDecomposition qmdLUD;

extern ostream& operator<<( ostream&, qmdLUDecomposition& );

#endif /* _qmdLUDecomposition_H_ */
