// qmdMatrix.h++

#ifndef _qmdMatrix_H_
#define _qmdMatrix_H_

#include <stddef.h>
#include <iostream.h>
#include <assert.h>
#include "qmdreald.h"
#include "qmdMatrixRef.h"

class qmdMatrix : public qmdMatrixRef
{
    reald *allocArray;
public:
    qmdMatrix( )
      : qmdMatrixRef( ), allocArray( 0 ) {}
    qmdMatrix( int h, int w );
    qmdMatrix( int h, int w, reald *data );
    qmdMatrix( const qmdMatrix& m );
    qmdMatrix( const qmdMatrixRef& m );
    qmdMatrix& set( int h, int w );
    qmdMatrix& set( int h, int w, reald *data );
    qmdMatrix& set( const qmdMatrixRef& m );
    qmdMatrix& operator=( const qmdMatrixRef& qmd ) { return set( qmd ); }
    virtual ~qmdMatrix() { if( allocArray) delete [] allocArray; }
};

#endif /* _qmdMatrix_H_ */


