// qmdSingularValueDecomposition.h++

#ifndef _qmdSingularValueDecomposition_H_
#define _qmdSingularValueDecomposition_H_

#include <iostream.h>
#include <math.h>
#include "qmdCompileOptions.h"
#include "qmdMatrixRef.h"
#include "qmdMatrix.h"
#include "qmdVectorRef.h"
#include "qmdVector.h"

class qmdSingularValueDecomposition
{
    qmdMatrix Umatrix;
    qmdVector singularValues;
    qmdMatrix Vmatrix;

private:

    static reald safePythag( const reald, const reald );
    static reald svdMakeBidiagonal( qmdMatrixRef& A, reald rowvec[], reald w[] );
    static qmdMatrixRef& svdMakeRHXforms( qmdMatrixRef& A,
					 reald rowvec[],
					 qmdMatrixRef& V );
    static qmdMatrixRef& svdMakeLHXforms( qmdMatrixRef& U, reald w[] );
    static void svdMakeDiagonal( qmdMatrixRef& U,
				 reald w[],
				 qmdMatrixRef& V,
				 reald rowvec[],
				 reald aNorm );

public:
    
    qmdSingularValueDecomposition() {}
    qmdSingularValueDecomposition( qmdMatrixRef& m ) { set( m ); }
    qmdSingularValueDecomposition& set( qmdMatrixRef& );
    qmdMatrixRef& getU() { return Umatrix; }
    qmdMatrixRef& getV() { return Vmatrix; }
    qmdVectorRef& getSingularValues() { return singularValues; }
    static reald* svd( qmdMatrixRef& A,
		      qmdMatrixRef& U,
		      reald w[],
		      qmdMatrixRef& V );
    ostream& print( ostream& );
};

typedef qmdSingularValueDecomposition qmdSVD;

extern ostream& operator<<( ostream&, qmdSingularValueDecomposition& );

#endif /* _qmdSingularValueDecomposition_H_ */
