// qmdUnitQuaternionRef.h++

#ifndef _qmdUnitQuaternionRef_H_
#define _qmdUnitQuaternionRef_H_

#include "qmdVectorRef.h"
#include "qmdMatrixRef.h"

class qmdUnitQuaternionRef : public qmdVectorRef
{
public:
    qmdUnitQuaternionRef()
      : qmdVectorRef() {}
    qmdUnitQuaternionRef( reald *rp )
      : qmdVectorRef( 4, rp ) {}
    qmdUnitQuaternionRef& set( reald* rp );
    qmdMatrixRef& getRotationMatrix( qmdMatrixRef& out ) const;
    qmdUnitQuaternionRef& setIdentity();
    qmdUnitQuaternionRef& setMultiply( const qmdUnitQuaternionRef&, 
				      const qmdUnitQuaternionRef& );
    qmdUnitQuaternionRef& setNormal();
    qmdUnitQuaternionRef& setInvert( const qmdUnitQuaternionRef& );
    inline qmdUnitQuaternionRef& operator=( const qmdUnitQuaternionRef& );
    qmdUnitQuaternionRef& setAddAngles( const qmdUnitQuaternionRef&,
				       const qmdVectorRef& angles );
    reald getAngle();
    qmdUnitQuaternionRef& setSubtract( const qmdUnitQuaternionRef&,
				      const qmdUnitQuaternionRef& );
    qmdUnitQuaternionRef& set( const qmdMatrixRef& );
};

inline
qmdUnitQuaternionRef&
qmdUnitQuaternionRef::operator=( const qmdUnitQuaternionRef& uq )
{
    qmdVectorRef::set( uq );
    return *this;
}

typedef qmdUnitQuaternionRef qmdQuatRef;

#endif /* _qmdUnitQuaternionRef_H_ */
