// Render.h


#include <gl\gl.h>
#include <gl\glu.h>
  
#ifdef __cplusplus 
extern "C" {
#endif    

#define DllExport	__declspec( dllexport )

//Methods
DllExport void RenderInitialize(HWND hWnd);
DllExport void RenderDrawScene(HWND hWnd);
DllExport void RenderResize(HWND hWnd);
DllExport void RenderCreate(HWND hWnd);
DllExport void RenderPaint(HWND hWnd);
DllExport void RenderClose(HWND hWnd);


// The WM_QUERYNEWPALETTE message informs a window that it is about to
// receive input focus. In response, the window receiving focus should
// realize its palette as a foreground palette and update its client
// area. If the window realizes its palette, it should return TRUE;
// otherwise, it should return FALSE.

DllExport BOOL RenderQueryNewPallette(HWND hWnd);

// The WM_PALETTECHANGED message informs all windows that the window
// with input focus has realized its logical palette, thereby changing 
// the system palette. This message allows a window without input focus
// that uses a color palette to realize its logical palettes and update
// its client area.
//
// This message is sent to all windows, including the one that changed
// the system palette and caused this message to be sent. The wParam of
// this message contains the handle of the window that caused the system
// palette to change. To avoid an infinite loop, care must be taken to
// check that the wParam of this message does not match the window's
// handle.

DllExport void RenderPalletteChanged(WPARAM wParam, HWND hWnd);


#ifdef __cplusplus 
}
#endif    
