// StiveViewerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "StiveViewer.h"
#include "StiveViewerDlg.h"
#include "render.h"
#include <direct.h>
#include "rffinderClient.h"
#include "lffinderClient.h"
#include <process.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

Vector4f HotPinkDC = {(float)0.851,(float)0.169,(float)0.541,(float)1.0};
Vector3f HotPinkSC = {(float)0.1,(float)0.0,(float)0.0};
Vector3f HotPinkEC = {(float)0.0,(float)0.0,(float)0.0};

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CStiveViewerDlg dialog

CStiveViewerDlg::CStiveViewerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CStiveViewerDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CStiveViewerDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
  inited = FALSE;
  stop = TRUE;
}

void CStiveViewerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CStiveViewerDlg)
	DDX_Control(pDX, IDC_VIEW, view);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CStiveViewerDlg, CDialog)
	//{{AFX_MSG_MAP(CStiveViewerDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_SIZE()
	ON_WM_TIMER()
	ON_COMMAND(IDC_START, OnStart)
	ON_COMMAND(IDC_STOP, OnStop)
	ON_WM_DESTROY()
	ON_COMMAND(IDC_CALIBRATE_SKIN, OnCalibrateSkin)
	ON_COMMAND(IDC_CALIBRATE_WORLD, OnCalibrateWorld)
	ON_COMMAND(IDC_CALIBRATE_CAMERAS, OnCalibrateCameras)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CStiveViewerDlg message handlers

BOOL CStiveViewerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
  FILE * fp = fopen("StiveViewer.cfg","r");
  char tmp[100];

  if(fp){
    fscanf(fp,"hostname = %s\n",hostname); 
    fscanf(fp,"lffinder = %s\n",tmp); lffinder_cmd = tmp;
    fscanf(fp,"rffinder = %s\n",tmp); rffinder_cmd = tmp;
    fscanf(fp,"sffinder = %s\n",tmp); sffinder_cmd = tmp;
    fscanf(fp,"worldbaby = %s\n",tmp); worldbaby_cmd = tmp;
    fscanf(fp,"skingrabber = %s\n",tmp); skingrab_cmd = tmp;
    fclose(fp);
  } else {
    lffinder_cmd = "lffinderServer";
    rffinder_cmd = "rffinderServer";
    sffinder_cmd = "testsffinder";
    skingrab_cmd = "SkinGrabber";
    worldbaby_cmd = "worldBaby";
  }

  SetWindowPos(NULL,0,0,300,300,SWP_NOZORDER|SWP_NOMOVE);

  RenderCreate(view.m_hWnd);
  RenderInitialize(view.m_hWnd);

  //putty.m_Type = CPutty::AUX_SPHERE;
  //memcpy(&putty.m_DiffuseColor,&HotPinkDC,sizeof(HotPinkDC));
  head = new CPutty;
  left = new CPutty;
  right = new CPutty;

  head->m_DiffuseColor[0] = 1.0;
	head->m_DiffuseColor[1] = 1.0;
	head->m_DiffuseColor[2] = 0.0;
	head->m_DiffuseColor[3] = 1;

  left->m_DiffuseColor[0] = 0.0;
	left->m_DiffuseColor[1] = 1.0;
	left->m_DiffuseColor[2] = 0.0;
	left->m_DiffuseColor[3] = 1;

  right->m_DiffuseColor[0] = 1.0;
	right->m_DiffuseColor[1] = 0.0;
	right->m_DiffuseColor[2] = 0.0;
	right->m_DiffuseColor[3] = 1;

  float s = 0.1;
  head->m_ScaleState[0] = s;
	head->m_ScaleState[1] = s;
	head->m_ScaleState[2] = s;

  left->m_ScaleState[0] = s;
	left->m_ScaleState[1] = s;
	left->m_ScaleState[2] = s;

  right->m_ScaleState[0] = s;
	right->m_ScaleState[1] = s;
	right->m_ScaleState[2] = s;

  head->m_TranslateState[0] = 0.0;
	head->m_TranslateState[1] = 1.0;
	head->m_TranslateState[2] = 0.0;

  left->m_TranslateState[0] = -1.0;
	left->m_TranslateState[1] = 0.0;
	left->m_TranslateState[2] = 0.0;

  right->m_TranslateState[0] = 1.0;
	right->m_TranslateState[1] = 0.0;
	right->m_TranslateState[2] = 0.0;
  frame = 0;
  
  inited = TRUE;
  Draw();
  
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CStiveViewerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CStiveViewerDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
    if(inited)
      Draw();
    view.ValidateRect(NULL);
		CDialog::OnPaint();
	}

}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CStiveViewerDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CStiveViewerDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
  if(IsWindow(view.m_hWnd)){
    RECT rect;
    this->GetClientRect(&rect);
    rect.bottom -= 5;
    rect.right -= 5;

    view.SetWindowPos(NULL,3,3,rect.right-rect.left,rect.bottom-rect.top,SWP_NOZORDER);
    RenderResize(view.m_hWnd);
    if(inited)
      Draw(); 
  }
  
}

void CStiveViewerDlg::Draw()
{
	HDC hDC;

  /*
	GLUquadricObj * quadObj;
	//	Colors
	Vector4f m_DiffuseColor;
	Vector4f m_SpecularColor;
	Vector4f m_EmissionColor;
	
	//  Material Properties
	float m_Shininess;

  quadObj = gluNewQuadric ();
  gluQuadricDrawStyle (quadObj, GLU_FILL);
  gluQuadricNormals (quadObj, GLU_SMOOTH);
	*/
	glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );
	glPushMatrix();

  /*
  	// Default Colors
	m_DiffuseColor[0] = 1.0;
	m_DiffuseColor[1] = 1.0;
	m_DiffuseColor[2] = 1.0;
	m_DiffuseColor[3] = 1;

	m_SpecularColor[0] = 0.0;
	m_SpecularColor[1] = 0.0;
	m_SpecularColor[2] = 0.0;
	m_SpecularColor[3] = 1;

	m_EmissionColor[0] = 0.0;
	m_EmissionColor[1] = 0.0;
	m_EmissionColor[2] = 0.0;
	m_EmissionColor[3] = 1;

	m_Shininess = 0.0;

  glMaterialfv(GL_FRONT, GL_DIFFUSE, m_DiffuseColor); 	
	glMaterialfv(GL_FRONT, GL_SPECULAR, m_SpecularColor); 	
	glMaterialfv(GL_FRONT, GL_EMISSION, m_EmissionColor);
	glMaterialf(GL_FRONT, GL_SHININESS, m_Shininess);

	  
  glTranslatef(0.0,0.0,-7.5);
	//glRotatef(180,0.0,1.0,0.0);
  gluSphere (quadObj, 1.0, 16, 16);
  */
    glTranslatef(0.0,0.0,-6.5);
  
  //putty.Update(0);
  //head.m_AppearanceChanged = TRUE;
  head->Draw();
 
  //left.m_AppearanceChanged = TRUE;
  left->Draw();

  //right.m_AppearanceChanged = TRUE;
  right->Draw();
/*
  glColor3f(1.0,1.0,1.0);
  glOrtho(-1.0,1.0,-1.0,1.0,-1.0,1.0);
  glBegin(GL_POLYGON);
  glVertex2f(-0.5,-0.5);
  glVertex2f(-0.5,0.5);
  glVertex2f(0.5,0.5);
  glVertex2f(0.5,-0.5);
  glEnd();
*/
	glPopMatrix();
	glFlush();

	hDC = wglGetCurrentDC();
	SwapBuffers(hDC);

  CDC * pDC = view.GetDC();
  RECT rect;
  view.GetClientRect(&rect);
  pDC->DrawText(text,&rect,DT_LEFT);
  view.ReleaseDC(pDC);
}

void CStiveViewerDlg::DrawPutty()
{
  
}

void Quat2VecTheta(double * q, double * r){
  double q1 = q[0];
  double q2 = q[1];
  double q3 = q[2];
  double q4 = q[3];
  double a;

  a = sqrt(q1*q1 + q2*q2 + q3*q3);
  r[0] = atan2(q4,a);
  r[1] = q1/a;
  r[2] = q2/a;
  r[3] = q3/a;
}

void Quat2Rot(double * q, double * T){
  double q1 = q[0];
  double q2 = q[1];
  double q3 = q[2];
  double q4 = q[3];

  T[0]= 1 - 2*q2*q2 - 2*q3*q3;      
  T[1]= 2*(q1*q2 - q3*q4); 
  T[2]= 2*(q1*q3 + q2*q4);

  T[3]= 2*(q1*q2 + q3*q4);      
  T[4]= 1-2*q1*q1 - 2*q3*q3; 
  T[5]= 2*(q2*q3 - q1*q4);

  T[6]= 2*(q1*q3 - q2*q4);      
  T[7]= 2*(q2*q3 + q1*q4);          
  T[8]= 1 - 2*q1*q1 - 2*q2*q2;

}

void CStiveViewerDlg::OnTimer(UINT nIDEvent) 
{
  if(stop){ 
    KillTimer(nIDEvent); 
    return;
  }

  float s = 20;
  double r[4];
  sffPersonPlus * p;
	p = sffinder.getNextPersonPlus();
  head->m_TranslateState[0] = p->head.world_ref.t[0]/s;
	head->m_TranslateState[1] = p->head.world_ref.t[1]/s;
	head->m_TranslateState[2] = p->head.world_ref.t[2]/s;
  
  head->m_ScaleState[0] = p->head.world_ref.s[0]/s*2;
	head->m_ScaleState[1] = p->head.world_ref.s[1]/s*2;
	head->m_ScaleState[2] = p->head.world_ref.s[2]/s*2;

  Quat2VecTheta(p->head.world_ref.q,r);
  head->m_RotateState[0] = r[0];
  head->m_DOF[0][0] = r[1];
  head->m_DOF[0][1] = r[2];
  head->m_DOF[0][2] = r[3];
  head->m_StateChanged = TRUE;

  left->m_TranslateState[0] = p->leftHand.world_ref.t[0]/s;
	left->m_TranslateState[1] = p->leftHand.world_ref.t[1]/s;
	left->m_TranslateState[2] = p->leftHand.world_ref.t[2]/s;

  left->m_ScaleState[0] = p->leftHand.world_ref.s[0]/s*2;
	left->m_ScaleState[1] = p->leftHand.world_ref.s[1]/s*2;
	left->m_ScaleState[2] = p->leftHand.world_ref.s[2]/s*2;

  /*
  Quat2Rot(p->leftHand.world_ref.q,left->M);
  left->UseMatrix = TRUE;
  */
  Quat2VecTheta(p->leftHand.world_ref.q,r);
  left->m_RotateState[0] = r[0];
  left->m_DOF[0][0] = r[1];
  left->m_DOF[0][1] = r[2];
  left->m_DOF[0][2] = r[3];
  left->m_StateChanged = TRUE;

  right->m_TranslateState[0] = p->rightHand.world_ref.t[0]/s;
	right->m_TranslateState[1] = p->rightHand.world_ref.t[1]/s;
	right->m_TranslateState[2] = p->rightHand.world_ref.t[2]/s;
  
  right->m_ScaleState[0] = p->rightHand.world_ref.s[0]/s*2;
	right->m_ScaleState[1] = p->rightHand.world_ref.s[1]/s*2;
	right->m_ScaleState[2] = p->rightHand.world_ref.s[2]/s*2;

  /*
  Quat2Rot(p->rightHand.world_ref.q,right->M);
  right->UseMatrix = TRUE;
  */
  Quat2VecTheta(p->rightHand.world_ref.q,r);
  right->m_RotateState[0] = r[0];
  right->m_DOF[0][0] = r[1];
  right->m_DOF[0][1] = r[2];
  right->m_DOF[0][2] = r[3];
  right->m_StateChanged = TRUE;

  frame = p->frameNumber;
  text.Format("%d",frame);
	Draw();
	CDialog::OnTimer(nIDEvent);
}

void CStiveViewerDlg::OnStart() 
{
  if(!stop) return;

  text = "Spawning Left ffinder...";
  Draw();

  _chdir(lffinder_cmd);
  if(_spawnl(_P_DETACH,lffinder_cmd,lffinder_cmd, NULL)==-1){
    AfxMessageBox("Unable to start lffinderServer - "+lffinder_cmd);
    return;
  }
  Sleep(1000);

  text = "Spawning Right ffinder...";
  Draw();

  _chdir(rffinder_cmd);
  if(_spawnl(_P_DETACH,rffinder_cmd,rffinder_cmd, NULL)==-1) {
    AfxMessageBox("Unable to start rffinderServer.");
    return;
  }
  Sleep(1000);

  text = "Spawning sffinder...";
  Draw();

  _chdir(sffinder_cmd);
  if(_spawnl(_P_DETACH,sffinder_cmd,sffinder_cmd, NULL)==-1) {
    AfxMessageBox("Unable to start sffinder.");
    return;
  }
  Sleep(1000); 

  if(sffinder.connect(hostname)){
    AfxMessageBox("Unable to connect.");
  } else {
    SetTimer(69,100,NULL);
    stop = FALSE;
  }
}

void CStiveViewerDlg::OnStop() 
{
  rffinderClient rc;
  lffinderClient lc;

  if(stop) return;

  stop = TRUE;
  text = "Quiting...";
  Draw();

  sffinder.quit();
  Sleep(1000);

  rc.connect(hostname);
  rc.quit();

  lc.connect(hostname);
  lc.quit();

  text = "Done.";
  Draw();
}

void CStiveViewerDlg::OnDestroy() 
{
  OnStop();	
	CDialog::OnDestroy();
	
}



void CStiveViewerDlg::OnCalibrateSkin() 
{
  _chdir(skingrab_cmd);
  if(_spawnl(_P_DETACH|_P_WAIT,skingrab_cmd,skingrab_cmd, NULL)==-1) {
    AfxMessageBox("Unable to start SkinGrabber.");
    return;
  }
}

void CStiveViewerDlg::OnCalibrateWorld() 
{
  if(!stop) OnStop();

  text = "World Calibration: Left ffinder...";
  Draw();

  _chdir(lffinder_cmd);
  if(_spawnl(_P_DETACH,lffinder_cmd,lffinder_cmd, NULL)==-1){
    AfxMessageBox("Unable to start lffinderServer.");
    return;
  }
  Sleep(1000);

  text = "World Calibration: Right ffinder...";
  Draw();

  _chdir(rffinder_cmd);
  if(_spawnl(_P_DETACH,rffinder_cmd,rffinder_cmd, NULL)==-1) {
    AfxMessageBox("Unable to start rffinderServer.");
    return;
  }
  Sleep(1000);

  text = "World Calibration: sffinder...";
  Draw();

  _chdir(sffinder_cmd);
  AfxMessageBox("Move your right hand Up and Down");
  if(_spawnl(_P_WAIT,"sffinder_world_updown","sffinder_world_updown", NULL)==-1) {
    AfxMessageBox("Unable to start sffinder_world_updown.");
  }

  AfxMessageBox("Move your right hand Left and Right");
  if(_spawnl(_P_WAIT,"sffinder_world_leftright","sffinder_world_leftright", NULL)==-1) {
    AfxMessageBox("Unable to start sffinder_world_leftright.");
  }

  rffinderClient rc;
  lffinderClient lc;

  stop = TRUE;
  text = "Camera Calibration: Quiting...";
  Draw();

  rc.connect(hostname);
  rc.quit();

  lc.connect(hostname);
  lc.quit();

  text = "World Calibration: worldBaby Phase...";
  Draw();
  //if(_spawnl(_P_WAIT,"d:/pcstive/bin/worldBaby","d:/pcstive/bin/worldBaby", NULL)==-1) {
  FILE * fp;
  char   buffer[128];
  sprintf(buffer,"del %s.out",worldbaby_cmd);
  system(buffer); 
  sprintf(buffer,"%s > worldBaby.out",worldbaby_cmd);
  if(system(buffer)==-1) {
    AfxMessageBox("Unable to start worldBaby. - "+worldbaby_cmd);
    return;
  }

  sprintf(buffer,"%s.out",worldbaby_cmd);
  fp = fopen(buffer,"r"); 
  if(fp==NULL){
    AfxMessageBox("Calibration Error: unable to open worldBaby.out.");
    return;
  }

  double x[13];
  int i;
  for(i=0;i<13;i++) fscanf(fp,"%le",&(x[i]));
  fclose(fp);

  _chdir(sffinder_cmd);
  fp = fopen("stive.sff.tmp","a+");
  fprintf(fp,"\n");
  for(i=0;i<3;i++) fprintf(fp,"%f ",x[i]);
  fprintf(fp,"\n");
  for(i=0;i<3;i++) fprintf(fp,"%f ",x[i+3]);
  fprintf(fp,"\n");
  for(i=0;i<3;i++) fprintf(fp,"%f ",x[i+6]);
  fprintf(fp,"\n");
  for(i=0;i<3;i++) fprintf(fp,"%f ",x[i+9]);
  fprintf(fp,"\n");
  fprintf(fp,"%f\n",x[12]);

  fclose(fp);
  system("copy stive.sff.tmp stive.sff");

  text = "World Calibration: Done.";
  Draw();
	
}

void CStiveViewerDlg::OnCalibrateCameras() 
{
  if(!stop) OnStop();

  text = "Camera Calibration: Left ffinder...";
  Draw();

  _chdir(lffinder_cmd);
  if(_spawnl(_P_DETACH,lffinder_cmd,lffinder_cmd, NULL)==-1){
    AfxMessageBox("Unable to start lffinderServer.");
    return;
  }
  Sleep(1000);

  text = "Camera Calibration: Right ffinder...";
  Draw();

  _chdir(rffinder_cmd);
  if(_spawnl(_P_DETACH,rffinder_cmd,rffinder_cmd, NULL)==-1) {
    AfxMessageBox("Unable to start rffinderServer.");
    return;
  }
  Sleep(1000);

  text = "Camera Calibration: sffinder...";
  Draw();

  _chdir(sffinder_cmd);
  AfxMessageBox("Move Both Hands Up and Down.");
  if(_spawnl(_P_WAIT,"sffinder_camera","sffinder_camera", NULL)==-1) {
    AfxMessageBox("Unable to start sffinder_camera.");
  }

  rffinderClient rc;
  lffinderClient lc;

  stop = TRUE;
  text = "Camera Calibration: Quiting...";
  Draw();

  rc.connect(hostname);
  rc.quit();

  lc.connect(hostname);
  lc.quit();

  int i;
  float x[7];
  FILE * fp = fopen("sffinder_camera.out","r");
  if(fp==NULL){
    AfxMessageBox("Calibration Error: unable to open sffinder_camera.out");
    return;
  }
  for(i=0;i<7;i++){
    fscanf(fp,"%f",&(x[i]));
  }
  fclose(fp);
///////////////////////////////////////////////////////////////
  fp = fopen("stive.sff","w");
  fprintf(fp,"%s\n",hostname);
  fprintf(fp,"%s\n",hostname);
  for(i=0;i<7;i++){
    fprintf(fp,"%f ",x[i]);
  }
  fprintf(fp,"\n1\n1\n");
  fprintf(fp,"\n\
-6.56576  -1.73626  -0.335745\n\
0.634148 0.385677 -0.617798 -0.259683\n\
0.785398\n");

  fprintf(fp,"\n\
 -0.640743 0.428965 1.90978\n\
 -0.945891 0.126943 -0.298624\n\
 -0.0730351 -0.979975 -0.185243\n\
 -0.316159 -0.15341 0.93622\n\
15.9259\n");
  fclose(fp);

  ////////////////////////////////////////////////////////////////////
  fp = fopen("stive.sff.tmp","w");
  fprintf(fp,"%s\n",hostname);
  fprintf(fp,"%s\n",hostname);
  for(i=0;i<7;i++){
    fprintf(fp,"%f ",x[i]);
  }
  fprintf(fp,"\n1\n1\n");
  fprintf(fp,"\n\
-6.56576  -1.73626  -0.335745\n\
0.634148 0.385677 -0.617798 -0.259683\n\
0.785398\n");

  fclose(fp);

///////////////////////////////////////////////////////////
  text = "Camera Calibration: Done.";
  Draw();

}
