// Utility.cpp
// This file contains useful routines and maybe some useless ones

#include "stdafx.h"
#include <math.h>
#include "types.h"
#include "putty.h"
#include "utility.h"

//This function calculates the normalized cross-product of AxB
void NormCrossProd(Vector3f & n, Vector3f & vA, Vector3f & vB)
{
	float d;
	n[0] = vA[1]*vB[2] - vA[2]*vB[1];
	n[1] = vA[2]*vB[0] - vA[0]*vB[2];
	n[2] = vA[0]*vB[1] - vA[1]*vB[0];
	d = (float)sqrt(n[0]*n[0] + n[1]*n[1] + n[2]*n[2]);
	n[0] = n[0]/d;
	n[1] = n[1]/d;
	n[2] = n[2]/d;

}

//This function converts from spherical coordinates to cartesian
void SphericalToXYZ(Vector3f & v, float r, float phi, float theta)
{
	v[0] = (float)(r*sin(phi)*cos(theta));
	v[1] = (float)(r*sin(theta)*sin(phi));
	v[2] = (float)(r*cos(phi));
}

//This function adds a control pt to a CPutty object and returns
//its identifying index
int AddControlPt(CPutty * pObj, float x, float y, float z, 
				  float xOffset, float yOffset, float zOffset,
				  float Rigidness, float Locality)
{
	ControlPt * NewCPs = new ControlPt[pObj->m_CPMax + 1];

	for(int i = 0; i < pObj->m_CPMax; i++)
	{
		NewCPs[i].Offset[0] = pObj->m_ControlPts[i].Offset[0];
		NewCPs[i].Offset[1] = pObj->m_ControlPts[i].Offset[1];
		NewCPs[i].Offset[2] = pObj->m_ControlPts[i].Offset[2];
		NewCPs[i].Point[0] = pObj->m_ControlPts[i].Point[0];
		NewCPs[i].Point[1] = pObj->m_ControlPts[i].Point[1];
		NewCPs[i].Point[2] = pObj->m_ControlPts[i].Point[2];
		NewCPs[i].Rigidness = pObj->m_ControlPts[i].Rigidness;
		NewCPs[i].Locality = pObj->m_ControlPts[i].Locality;
	}

	NewCPs[pObj->m_CPMax].Offset[0] = xOffset;
	NewCPs[pObj->m_CPMax].Offset[1] = yOffset;
	NewCPs[pObj->m_CPMax].Offset[2] = zOffset;
	NewCPs[pObj->m_CPMax].Point[0] = x;
	NewCPs[pObj->m_CPMax].Point[1] = y;
	NewCPs[pObj->m_CPMax].Point[2] = z;
	NewCPs[pObj->m_CPMax].Rigidness = Rigidness;
	NewCPs[pObj->m_CPMax].Locality = Locality;

	pObj->m_CPMax++;
	
	delete pObj->m_ControlPts;

	pObj->m_ControlPts = NewCPs;

	return pObj->m_CPMax - 1;
}