// HowSlow.c++

#include "HowSlow.h"
#include <stdio.h>

HowSlow::HowSlow( int T )
  : interval( T ),
    count( 0 )
{}

void
HowSlow::sample()
{
    /*
      // count = number of calls since init, *including* this one
      // Thusly, when count == NFRAMES, the time elapsed is for NFRAMES
      //  calls to processFrame()
      */
    
    if ( count==0 )  
       {
	   gettimeofday( &start, NULL);
	   count = 1;
	   return;
       } 
    else if ( count++ == interval ) 
       {
	   gettimeofday( &end , NULL);
	   time_sec = (end.tv_usec - start.tv_usec)/1000000.0 + 
	      (end.tv_sec - start.tv_sec);
	   rate = (double) interval / time_sec; /* // frames per second */
	   fprintf ( stderr, "[%2.2f Hz, (%d frames, %d total, %.6f sec)]\n", 
		     rate, interval, (int)(30.*time_sec), time_sec );
	   start = end;
	   count = 1;
	   return;
       } 
}

