// iotools.h++

#ifndef _iotools_H_
#define _iotools_H_

#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <iostream.h>

class iotools
{
public:
    static int wordpeek( istream&, char* s ); // is s the next token?
};

template < class T_ >
inline
ostream&
iotools_printVector( ostream& os, T_* v, int n )
{
    while( n-- )
       os << *v++ << " ";
    return os;
}

template < class T_ >
inline
istream&
iotools_scanVector( istream& is, T_* v, int n )
{
    while( n-- )
       is >> *v++;
    return is;
}

template < class T1_, class T2_ >
inline
void
iotools_copyVector( int n, const T1_* v1, T2_* v2 )
{
    while( n-- )
       *v2++ = *v1++;
}

template < class T_ >
inline
void
iotools_zeroVector( T_* v, int n )
{
    while( n-- )
       *v++ = T_(0);
}

#endif /* _iotools_H_ */
