// $CopyrightHeader$

// Copyright (C) 1997 by Christopher R. Wren and the Massachusetts
// Institute of Technology
//
// COMMERCIAL DISCLAIMER:
//
// This software is intended for research purposes only and contains
// unlicensed software, in original and modified forms, from various
// sources including the Free Software Foundation.  These programs
// shall not be used, rewritten, or adapted as the basis of a
// commercial software or hardware product without first obtaining
// appropriate licenses from the owners of the original software
// copyrights.
//
// In the case of copyrighted software fragments obtained from the
// Free Software Foundation: you can redistribute it and/or modify it
// under the terms of the GNU Library General Public License as
// published by the Free Software Foundation.  This software is
// distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library General
// Public License for more details.  You should have received a copy
// of the GNU Library General Public License and the GNU General
// Public License along with this software; if not, write to the Free
// Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.


// MIT COPYRIGHT:
// 
// Copyright 1995  by  the  Massachusetts Institute  of Technology.   All  
// rights reserved.
// 
// Developed  by Ali Azarbayejani at the Media Laboratory, MIT,
// Cambridge, Massachusetts.
// 
// Permission to use, copy,  or modify this software and  its documentation
// for  educational  and  research purposes only and without fee  is hereby
// granted, provided  that this copyright notice and the original authors's
// names appear  on all copies and supporting documentation.  If individual
// files are  separated from  this  distribution directory  structure, this
// copyright notice must be included.  For any other uses of this software,
// in original or  modified form, including but not limited to distribution
// in whole or in  part, specific  prior permission  must be  obtained from
// MIT.  These programs shall not  be  used, rewritten, or  adapted as  the
// basis  of  a commercial  software  or  hardware product  without first
// obtaining appropriate licenses  from MIT.  MIT. makes no representations
// about the suitability of this  software for any purpose.  It is provided
// "as is" without express or implied warranty.

// Person.h++

class Prior;

#ifndef _Prior_H_
#define _Prior_H_
//#include <rpc/rpc.h>
//#include "ffinder_svc.h"

#include "multiple_ffinder.h"
#include "ffinder_pc.h"
#include "QuickMath.h"
#include "vliRGBImageRef.h"
#include "qmStatistics.h"
#include "BlobMan.h"

class Prior 
{
  ffPerson person;
  qmVector imageCenter;
  int width;
  int height;
  qmGaussian spatialStats[3];
  qmGaussianInv invSpatialStats[3];

 public:
  static void drawPrior( vliRGBImageRef&, vliRGBPixel&, 
			 const qmVectorRef, const qmMatrixRef );

  static vliRGBPixel partColors[3];

  Prior() : imageCenter(2), width(0), height(0) {};
  void Create(int w, int h) {width = w; height = h; imageCenter = 2; init(-1,0,0,0);}
  Prior( int w, int h ) 
       { Create(w,h); }; 
  void init( long frameNumber,
	     long timeSec,
	     long timeUsec,
	     int PriorExists );
  void set(ffPerson&);
  void draw( vliRGBImageRef&, vliRGBPixel* = 0 );
  
  int valid(int i);
  const qmGaussianRef& getSpatial(int i);
  const qmGaussianInvRef& getInvSpatial(int i);
};

#endif /* _Prior_H_ */

