// $CopyrightHeader$

// Copyright (C) 1996 by Ali Azarbayejani and the Massachusetts
// Institute of Technology
//
// COMMERCIAL DISCLAIMER:
//
// This software is intended for research purposes only and contains
// unlicensed software, in original and modified forms, from various
// sources including the Free Software Foundation.  These programs
// shall not be used, rewritten, or adapted as the basis of a
// commercial software or hardware product without first obtaining
// appropriate licenses from the owners of the original software
// copyrights.
//
// In the case of copyrighted software fragments obtained from the
// Free Software Foundation: you can redistribute it and/or modify it
// under the terms of the GNU Library General Public License as
// published by the Free Software Foundation.  This software is
// distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library General
// Public License for more details.  You should have received a copy
// of the GNU Library General Public License and the GNU General
// Public License along with this software; if not, write to the Free
// Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.


// MIT COPYRIGHT:
// 
// Copyright 1995  by  the  Massachusetts Institute  of Technology.   All  
// rights reserved.
// 
// Developed  by Ali Azarbayejani at the Media Laboratory, MIT,
// Cambridge, Massachusetts.
// 
// Permission to use, copy,  or modify this software and  its documentation
// for  educational  and  research purposes only and without fee  is hereby
// granted, provided  that this copyright notice and the original authors's
// names appear  on all copies and supporting documentation.  If individual
// files are  separated from  this  distribution directory  structure, this
// copyright notice must be included.  For any other uses of this software,
// in original or  modified form, including but not limited to distribution
// in whole or in  part, specific  ffPrior permission  must be  obtained from
// MIT.  These programs shall not  be  used, rewritten, or  adapted as  the
// basis  of  a commercial  software  or  hardware product  without first
// obtaining appropriate licenses  from MIT.  MIT. makes no representations
// about the suitability of this  software for any purpose.  It is provided
// "as is" without express or implied warranty.

// ffCellImage.h++

#ifndef _ffCellImage_H_
#define _ffCellImage_H_
#include "ffinderenv.h"
#include "StateImage.h"
#include "ffCell.h"
#include "ffPixel.h"
#include "ffCoords.h"
class ffCellImage : public StateImage< ffCell >, public FfinderEnv
{
    StateImage< ffPixel >* ffPixelMap;
    ffPixel** ffPixels;
    int ffCellWidth;
    int ffCellHeight;
    void initffCell( int i, int j, int nw, int nh, int pw, int ph, ffPixel** p );
    static ffCoords tmp;
    void error( char* fn, char* msg );
 public:
    ffCellImage()
      : ffPixelMap(0), ffPixels(0), ffCellWidth(0), ffCellHeight(0) {}
    ~ffCellImage() { if( ffPixels ) delete ffPixels; }
    void init( StateImage< ffPixel >*, int nw, int nh );
    inline ffCoords& getffCellffCoords( const ffCoords& ffPixelffCoords );
};

inline
ffCoords&
ffCellImage::getffCellffCoords( const ffCoords& pc )
{
    tmp.u = pc.u / ffCellWidth;
    tmp.v = pc.v / ffCellHeight;
    return tmp;
}

#endif /* _ffCellImage_H_ */
