// FfinderEnv.h: interface for the FfinderEnv class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FFINDERENV_H__2ABC9113_27F8_11D3_80DE_005004782BFA__INCLUDED_)
#define AFX_FFINDERENV_H__2ABC9113_27F8_11D3_80DE_005004782BFA__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "QuickMath.h"
#include "Blob.h"
#include "StateImage.h"
#include "CellImage.h"

class FfinderEnv  
{
public:

  // Blob.h
  StateImage<Pixel> stateImage;
  CellImage cellImage;
  vliRGBImage rgbImage;
  int searchCoordsCount;
  Coords* searchCoords;
  float simThresh2;
  int trackDelta;
  int headDelta;
  real collideThresh;
  int mode;
  int verbose;
  int expandCheck;
  int subWoohoo;
  int deltaWoohoo;

  void initBlobClass( int w, int h, int nw, int nh );
  void clearBlobClass() { stateImage.clear(); cellImage.clear(); }

  int initCount;
  int initWidth;
  int initFnBlob( Pixel* pp );

  int expandWoohoo3Blob( Coords& seed,
			    const qmGaussianInvRef& colorClass,
			    vliRGBImageRef& vim,
			    int n,
			    qmGaussianInvRef* space,
			    real* dist2,
			    int* crash,
			    llSingleP<Pixel>& list );

  // BlobMan.h
  real fleshMean[3];
  real fleshInvCovariance[9];
  real fleshCovariance[9];
  qmGaussianInv fleshClass;

  int maxCullBlobs;
  int cullMinBlob;
  int blobSpacing;
  int blobOffset;
  int searchMargin;
//  int verbose;
  int o_data[3][2];
  int cellWidth;
  int cellHeight;
  vliRGBPixel partColors[3];
  int coopMode;
  int crashThresh;
  real crashRatio;
  int existenceThresh;

  FfinderEnv();
	virtual ~FfinderEnv();

};

#endif // !defined(AFX_FFINDERENV_H__2ABC9113_27F8_11D3_80DE_005004782BFA__INCLUDED_)
