// $CopyrightHeader$

// Copyright (C) 1996 by Ali Azarbayejani and the Massachusetts
// Institute of Technology
//
// COMMERCIAL DISCLAIMER:
//
// This software is intended for research purposes only and contains
// unlicensed software, in original and modified forms, from various
// sources including the Free Software Foundation.  These programs
// shall not be used, rewritten, or adapted as the basis of a
// commercial software or hardware product without first obtaining
// appropriate licenses from the owners of the original software
// copyrights.
//
// In the case of copyrighted software fragments obtained from the
// Free Software Foundation: you can redistribute it and/or modify it
// under the terms of the GNU Library General Public License as
// published by the Free Software Foundation.  This software is
// distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library General
// Public License for more details.  You should have received a copy
// of the GNU Library General Public License and the GNU General
// Public License along with this software; if not, write to the Free
// Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.


// MIT COPYRIGHT:
// 
// Copyright 1995  by  the  Massachusetts Institute  of Technology.   All  
// rights reserved.
// 
// Developed  by Ali Azarbayejani at the Media Laboratory, MIT,
// Cambridge, Massachusetts.
// 
// Permission to use, copy,  or modify this software and  its documentation
// for  educational  and  research purposes only and without fee  is hereby
// granted, provided  that this copyright notice and the original authors's
// names appear  on all copies and supporting documentation.  If individual
// files are  separated from  this  distribution directory  structure, this
// copyright notice must be included.  For any other uses of this software,
// in original or  modified form, including but not limited to distribution
// in whole or in  part, specific  prior permission  must be  obtained from
// MIT.  These programs shall not  be  used, rewritten, or  adapted as  the
// basis  of  a commercial  software  or  hardware product  without first
// obtaining appropriate licenses  from MIT.  MIT. makes no representations
// about the suitability of this  software for any purpose.  It is provided
// "as is" without express or implied warranty.

// Cell.h++

#ifndef _Cell_H_
#define _Cell_H_
#include "ffinderenv.h"
#include "vliRGBImageRef.h"
#include "qmStatistics.h"
#include "Pixel.h"
#include "StateImage.h"
class Cell : public FfinderEnv
{
    int pixelCount;
    int width;
    Pixel** array;
    int stackCount;
    Pixel** stack;
    static ostream& alert( char* fn, char* msg );
    static void error( char* fn, char* msg );
 public:
    Cell()
      : pixelCount(0), width(0), array(0), stackCount(0), stack(0) {}
    static float classifyPercentThresh;
    static real maha2ciel;
    static real mutualThresh;
    void init( int w, int h, Pixel** );
    int set( const vliRGBImageRef& );
    int classify( const qmGaussianInvRef& colorClass, int sub = 1 );
    int setAndClassify( const vliRGBImageRef&,
			const qmGaussianInvRef& colorClass,
			int n,
			qmGaussianInvRef* sp,
			real* dist,
			int* crash,
			int sub = 1 );
    inline void setPixel( int i, int j, Pixel* pp ) { array[j*width+i]=pp; }
    inline Pixel* pop() { return( (stackCount) ? stack[--stackCount] : 0 ); }
};

#endif /* _Cell_H_ */
