// $CopyrightHeader$

// Copyright (C) 1996 by Ali Azarbayejani and the Massachusetts
// Institute of Technology
//
// COMMERCIAL DISCLAIMER:
//
// This software is intended for research purposes only and contains
// unlicensed software, in original and modified forms, from various
// sources including the Free Software Foundation.  These programs
// shall not be used, rewritten, or adapted as the basis of a
// commercial software or hardware product without first obtaining
// appropriate licenses from the owners of the original software
// copyrights.
//
// In the case of copyrighted software fragments obtained from the
// Free Software Foundation: you can redistribute it and/or modify it
// under the terms of the GNU Library General Public License as
// published by the Free Software Foundation.  This software is
// distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library General
// Public License for more details.  You should have received a copy
// of the GNU Library General Public License and the GNU General
// Public License along with this software; if not, write to the Free
// Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.


// MIT COPYRIGHT:
// 
// Copyright 1995  by  the  Massachusetts Institute  of Technology.   All  
// rights reserved.
// 
// Developed  by Ali Azarbayejani at the Media Laboratory, MIT,
// Cambridge, Massachusetts.
// 
// Permission to use, copy,  or modify this software and  its documentation
// for  educational  and  research purposes only and without fee  is hereby
// granted, provided  that this copyright notice and the original authors's
// names appear  on all copies and supporting documentation.  If individual
// files are  separated from  this  distribution directory  structure, this
// copyright notice must be included.  For any other uses of this software,
// in original or  modified form, including but not limited to distribution
// in whole or in  part, specific  prior permission  must be  obtained from
// MIT.  These programs shall not  be  used, rewritten, or  adapted as  the
// basis  of  a commercial  software  or  hardware product  without first
// obtaining appropriate licenses  from MIT.  MIT. makes no representations
// about the suitability of this  software for any purpose.  It is provided
// "as is" without express or implied warranty.

// Person.c++

#include "Person.h"
void
Person::set( long frameNumber,
	     long timeSec,
	     long timeUsec,
	     int personExists,
	     const qmVectorRef& hdVec,
	     const qmVectorRef& lhVec,
	     const qmVectorRef& rhVec )
{
    person.frameNumber = frameNumber;
    person.timestampSec = timeSec;
    person.timestampUsec = timeUsec;
    person.personExists = personExists;
    person.leftHand.valid = int(lhVec.getValue( 5 ));
    person.leftHand.u = lhVec.getValue( 0 );
    person.leftHand.v = lhVec.getValue( 1 );
    person.leftHand.suu = lhVec.getValue( 2 );
    person.leftHand.svv = lhVec.getValue( 3 );
    person.leftHand.suv = lhVec.getValue( 4 );
    person.rightHand.valid = int(rhVec.getValue( 5 ));
    person.rightHand.u = rhVec.getValue( 0 );
    person.rightHand.v = rhVec.getValue( 1 );
    person.rightHand.suu = rhVec.getValue( 2 );
    person.rightHand.svv = rhVec.getValue( 3 );
    person.rightHand.suv = rhVec.getValue( 4 );
    person.head.valid = int(hdVec.getValue( 5 ));
    person.head.u = hdVec.getValue( 0 );
    person.head.v = hdVec.getValue( 1 );
    person.head.suu = hdVec.getValue( 2 );
    person.head.svv = hdVec.getValue( 3 );
    person.head.suv = hdVec.getValue( 4 );
}
