// SlffinderClient.c++

#include "lffinderClient.h"
//#include <unistd.h>
#include <limits.h>
#include <iostream.h>
#include "iotools.h"

qmMatrix lffinderClient::world_rotation(3,3);
qmVector lffinderClient::world_translation(3);
float    lffinderClient::world_scale;
qmMatrix lffinderClient::stereo_rotation(3,3);
qmVector lffinderClient::stereo_translation(3);


lffinderClient::lffinderClient( char* serverHostname )
  : lastFrame( -1 ), lastGot( GOTNONE )
{
  pszUuid = NULL;             //= NULL;
  strcpy((char *)pszProtocolSequence,"ncacn_np"); //= "ncacn_np";
  pszNetworkAddress = NULL;   //= NULL;
  strcpy((char*)pszEndpoint,"\\pipe\\lffinder");         //= "\\pipe\\hello";
  pszOptions = NULL;          //= NULL;
  pszStringBinding = NULL;    //= NULL;
  strcpy((char *)pszString,"hello, lffinder");           //= "hello, world";

    person.rightHand.valid = 0;
    person.leftHand.valid = 0;
    person.head.valid = 0;
    if( serverHostname )
       if( connect( serverHostname ) )
	        cerr << "connection failed" << endl;
}

lffinderClient::~lffinderClient()
{
    /*  The calls to the remote procedures are complete. */
    /*  Free the string and the binding handle           */
    RpcStringFree(&pszStringBinding);  // remote calls done; unbind
    RpcBindingFree(&lffinder_IfHandle);  // remote calls done; unbind
}

int
lffinderClient::connect( char* serverHostname )
{
    RPC_STATUS status;

    pszNetworkAddress = (unsigned char *)serverHostname;

    /* Use a convenience function to concatenate the elements of */
    /* the string binding into the proper sequence.              */
    status = RpcStringBindingCompose(pszUuid,
                                     pszProtocolSequence,
                                     pszNetworkAddress,
                                     pszEndpoint,
                                     pszOptions,
                                     &pszStringBinding);
    printf("RpcStringBindingCompose returned 0x%x\n", status);
    printf("pszStringBinding = %s\n", pszStringBinding);
    if (status) {
        exit(status);
    }

    /* Set the binding handle that will be used to bind to the server. */
    status = RpcBindingFromStringBinding(pszStringBinding,
                                         &lffinder_IfHandle);
    printf("RpcBindingFromStringBinding returned 0x%x\n", status);
    if (status) {
        exit(status);
    }

    return 0;
}

ffPerson*
lffinderClient::getPerson()
{

    person = lffGET_CURRENT();
    lastFrame = person.frameNumber;
    lastGot = GOTPERSON;

    lffFRAME();

    return &person;
}

ffPerson*
lffinderClient::getNextPerson()
{
    person = lffGET_FRAME_RESULT();
    lastFrame = person.frameNumber;
    lastGot = GOTPERSON;
    lffFRAME();
    return &person;
}

ostream&
lffinderClient::print( ostream& os )
{
    return os;
}

void
lffinderClient::init()
{
  lffforceinit();
}

void
lffinderClient::setPriors(ffPerson *priors)
{
  lffSET_PRIORS(*priors);
}

//////////////////////////////////////////////////////////////////////////////


void lffinderClient::quit()
{
  lffQUIT();
    RpcStringFree(&pszStringBinding);  // remote calls done; unbind
  RpcBindingFree(&lffinder_IfHandle);  // remote calls done; unbind

}
