// SrffinderClient.c++

#include "rffinderClient.h"
//#include <unistd.h>
#include <limits.h>
#include <iostream.h>
#include "iotools.h"

qmMatrix rffinderClient::world_rotation(3,3);
qmVector rffinderClient::world_translation(3);
float    rffinderClient::world_scale;
qmMatrix rffinderClient::stereo_rotation(3,3);
qmVector rffinderClient::stereo_translation(3);


rffinderClient::rffinderClient( char* serverHostname )
  : lastFrame( -1 ), lastGot( GOTNONE )
{
  pszUuid = NULL;             //= NULL;
  strcpy((char *)pszProtocolSequence,"ncacn_np"); //= "ncacn_np";
  pszNetworkAddress = NULL;   //= NULL;
  strcpy((char*)pszEndpoint,"\\pipe\\rffinder");         //= "\\pipe\\hello";
  pszOptions = NULL;          //= NULL;
  pszStringBinding = NULL;    //= NULL;
  strcpy((char *)pszString,"hello, rffinder");           //= "hello, world";

    person.rightHand.valid = 0;
    person.leftHand.valid = 0;
    person.head.valid = 0;
    if( serverHostname )
       if( connect( serverHostname ) )
	        cerr << "connection failed" << endl;
}

rffinderClient::~rffinderClient()
{
    /*  The calls to the remote procedures are complete. */
    /*  Free the string and the binding handle           */
    RpcStringFree(&pszStringBinding);  // remote calls done; unbind
    RpcBindingFree(&rffinder_IfHandle);  // remote calls done; unbind
}

int
rffinderClient::connect( char* serverHostname )
{
    RPC_STATUS status;

    pszNetworkAddress = (unsigned char *)serverHostname;

    /* Use a convenience function to concatenate the elements of */
    /* the string binding into the proper sequence.              */
    status = RpcStringBindingCompose(pszUuid,
                                     pszProtocolSequence,
                                     pszNetworkAddress,
                                     pszEndpoint,
                                     pszOptions,
                                     &pszStringBinding);
    printf("RpcStringBindingCompose returned 0x%x\n", status);
    printf("pszStringBinding = %s\n", pszStringBinding);
    if (status) {
        exit(status);
    }

    /* Set the binding handle that will be used to bind to the server. */
    status = RpcBindingFromStringBinding(pszStringBinding,
                                         &rffinder_IfHandle);
    printf("RpcBindingFromStringBinding returned 0x%x\n", status);
    if (status) {
        exit(status);
    }

    return 0;
}

ffPerson*
rffinderClient::getPerson()
{

    person = rffGET_CURRENT();
    lastFrame = person.frameNumber;
    lastGot = GOTPERSON;

    rffFRAME();

    return &person;
}

ffPerson*
rffinderClient::getNextPerson()
{
    person = rffGET_FRAME_RESULT();
    lastFrame = person.frameNumber;
    lastGot = GOTPERSON;
    rffFRAME();
    return &person;
}

ostream&
rffinderClient::print( ostream& os )
{
    return os;
}

void
rffinderClient::init()
{
  rffforceinit();
}

void
rffinderClient::setPriors(ffPerson *priors)
{
  rffSET_PRIORS(*priors);
}


void rffinderClient::quit()
{
  rffQUIT();
    RpcStringFree(&pszStringBinding);  // remote calls done; unbind
  RpcBindingFree(&rffinder_IfHandle);  // remote calls done; unbind

}
