// SffinderClient.c++

#include "ffinderClient.h"
//#include <unistd.h>
#include <limits.h>
#include <iostream.h>
#include "iotools.h"

qmMatrix ffinderClient::world_rotation(3,3);
qmVector ffinderClient::world_translation(3);
float    ffinderClient::world_scale;
qmMatrix ffinderClient::stereo_rotation(3,3);
qmVector ffinderClient::stereo_translation(3);


ffinderClient::ffinderClient( char* serverHostname )
  : lastFrame( -1 ), lastGot( GOTNONE )
{
    person.rightHand.valid = 0;
    person.leftHand.valid = 0;
    person.head.valid = 0;
    if( serverHostname )
       if( connect( serverHostname ) )
	        cerr << "connection failed" << endl;
}

ffinderClient::~ffinderClient()
{
    /*  The calls to the remote procedures are complete. */
    /*  Free the string and the binding handle           */
    RpcStringFree(&pszStringBinding);  // remote calls done; unbind
    RpcBindingFree(&ffinder_IfHandle);  // remote calls done; unbind
}

int
ffinderClient::connect( char* serverHostname )
{
    RPC_STATUS status;

    pszNetworkAddress = (unsigned char *)serverHostname;

    /* Use a convenience function to concatenate the elements of */
    /* the string binding into the proper sequence.              */
    status = RpcStringBindingCompose(pszUuid,
                                     pszProtocolSequence,
                                     pszNetworkAddress,
                                     pszEndpoint,
                                     pszOptions,
                                     &pszStringBinding);
    printf("RpcStringBindingCompose returned 0x%x\n", status);
    printf("pszStringBinding = %s\n", pszStringBinding);
    if (status) {
        exit(status);
    }

    /* Set the binding handle that will be used to bind to the server. */
    status = RpcBindingFromStringBinding(pszStringBinding,
                                         &ffinder_IfHandle);
    printf("RpcBindingFromStringBinding returned 0x%x\n", status);
    if (status) {
        exit(status);
    }

    return 0;
}

ffPerson*
ffinderClient::getPerson()
{

    person = ffGET_CURRENT();
    lastFrame = person.frameNumber;
    lastGot = GOTPERSON;

    ffFRAME();

    return &person;
}

ffPerson*
ffinderClient::getNextPerson()
{
    person = ffGET_FRAME_RESULT();
    lastFrame = person.frameNumber;
    lastGot = GOTPERSON;
    ffFRAME();
    return &person;
}

ostream&
ffinderClient::print( ostream& os )
{
    return os;
}

void
ffinderClient::init()
{
  ffforceinit();
}

void
ffinderClient::setPriors(ffPerson *priors)
{
  ffSET_PRIORS(*priors);
}

