// glDisplay.c++

#include "glDisplay.h"

glDisplay::glDisplay( int h, int w, char *name, int p )
: height( h ),
    width( w ),
    packing( p )
{
  MilImage = M_NULL;
  MilDisplay = M_NULL;
    init( h, w, name, p );
}

glDisplay::~glDisplay()
{
close();
}

void glDisplay::close(){
  if(MilImage!=M_NULL)
    MbufFree(MilImage);
  MilImage = M_NULL;
  if(MilDisplay!=M_NULL)
    MdispFree(MilDisplay);
  MilDisplay = M_NULL;
}

void
glDisplay::init( int h, int w, char *name, int p )
{
	 height = h; 
	 width = w;
	 packing = p;

   MdispAlloc(MatroxEnvironment::VgaSystem,M_DEFAULT,name,M_DEFAULT,&MilDisplay);

     /* Allocate a color display image buffer to perform processing in it. */
   if(packing==RGB){
     MbufAllocColor(MatroxEnvironment::VgaSystem,
                   3,
                   width, 
                   height,
                   8+M_UNSIGNED, M_IMAGE+M_DISP+M_BGR24+M_PACKED,
                   &MilImage);
   } else {

   }
  
  /* Clear the image buffer. */
   MbufClear(MilImage, 0L);
      
  /* Display the image buffer. */
   MdispSelect(MilDisplay, MilImage);

}

glDisplay&
glDisplay::operator=( unsigned long *p )
{
  MbufPutColor(MilImage,M_BGR32+M_PACKED,M_ALL_BAND,(void*)p);
  return *this;
}
