// noErfExponential.h++

#ifndef _noErfExponential_H_
#define _noErfExponential_H_

#include <math.h>
#include "noErrorFunction.h"

class noErfExponential : public noErrorFunction
{
    enum { AMPL = 0, RATE = 1, N = 2 };
    qmdVector y;
public:
    noErfExponential() {}
    void init( qmdVectorRef& y );
    const qmdVectorRef& operator()( const qmdVectorRef& x );
    const qmdMatrixRef& jacobian( const qmdVectorRef& x );
    const qmdVectorRef& add( const qmdVectorRef& x, const qmdVectorRef& dx );
    qmdVectorRef& generateData( double a, double r, qmdVectorRef& y_out );
};

#endif /* _noErfExponential_H_ */
