// cgTriangle.h++

#ifndef _cgTriangle_H_
#define _cgTriangle_H_

#include <iostream.h>
#include <fstream.h>
#include "QuickMathDouble.h"
#include "qmdMinMax.h"

// three coord frames world (w), left (l), right (r)
// P_x = Txp_x		( point "p" in "x" frame is vector from "x" origin
// 			  to "p" represented in "x" basis )
// P_r  =  Trl_r  +  Rrl . P_l	( Trp = Trl + Tlp )
// P_w  =  Twl_w  +  Rwl .

class cgTriangle
{
protected:

    qmdVector T;
    qmdMatrix R;
    reald bL;
    reald bR;
    int state;
    qmdUnitQuaternion q;

public:

    cgTriangle();
    cgTriangle( char *filename );
    istream& scan( istream& );
    int FScan( char * );
    reald Point( reald uL, reald vL, reald uR, reald vR, qmdVectorRef& p,
		reald* residual = 0 );
    reald PointAlt( reald uL, reald vL, reald uR, reald vR, qmdVectorRef& p );
    // reald FakePoint( reald uL, reald vL, reald uR, reald vR, qmdVectorRef& p );
    operator int() { return state; }
    qmdVectorRef& Translation() { return T; }
    qmdMatrixRef& Rotation() { return R; }
    qmdUnitQuaternion& Q() { return q; }
    reald& BL() { return bL; }
    reald& BR() { return bR; }
    istream& scanEstRecord( istream& );
    void ellipse( qmdVectorRef& mL, qmdMatrixRef& CL,
		  qmdVectorRef& mR, qmdMatrixRef& CR,
		  qmdVectorRef& m3out, qmdMatrixRef& C3out );
    void ellipse( qmdVectorRef& mL, qmdMatrixRef& CL,
		  qmdVectorRef& mR, qmdMatrixRef& CR,
		  qmdVectorRef& m3out, qmdMatrixRef& C3out,
		  qmdMatrixRef& Ut, qmdVectorRef& s, qmdMatrixRef& Vt );
    static reald defaultSV;
    static int svinvert;
    ostream& print( ostream& );

private:
    void projectionJacobian( qmdMatrixRef&, qmdVectorRef&, reald );
    void combineJacobians( qmdMatrixRef&, qmdMatrixRef&, qmdMatrixRef& );
    void compute3DCovariance( qmdMatrixRef&, qmdMatrixRef&, qmdVectorRef& );
    void compute3DCovariance( qmdMatrixRef&, qmdMatrixRef&, qmdVectorRef&,
			      qmdMatrixRef&, qmdVectorRef&, qmdMatrixRef& );
};

#endif /* _cgTriangle_H_ */

