// cgTriangleStereo.h++

#ifndef _cgTriangleStereo_H_
#define _cgTriangleStereo_H_

#include <iostream.h>
#include "cgTriangle.h"

class cgTriangleStereo : public cgTriangle
{
private:
    // cgTriangle* triangle;
    // these are reference transforms (not coordinate transforms)
    reald tL[3];
    reald qL[4];
    reald tR[3];
    reald qR[4];
    void computeTriangle();
public:
    cgTriangleStereo();
    inline reald point( qmdVectorRef& p2L, qmdVectorRef& p2R, qmdVectorRef& p3,
		       reald* residual = 0 );
#if 0
    inline void ellipse( qmdVectorRef& mL, qmdMatrixRef& CL,
			 qmdVectorRef& mR, qmdMatrixRef& CR,
			 qmdVectorRef& m3out, qmdMatrixRef& C3out );
#endif
    void setLeftCoordinateTransform( reald, reald, reald,
				     reald, reald, reald, reald );
    inline void setLeftReferenceTransform( reald, reald, reald,
					    reald, reald, reald, reald );
    inline void setLeftBeta( reald );
    void setRightCoordinateTransform( reald, reald, reald,
				      reald, reald, reald, reald );
    inline void setRightReferenceTransform( reald, reald, reald,
					    reald, reald, reald, reald );
    inline void setRightBeta( reald );
    inline ostream& print( ostream& );
    static void computeTriangle( reald* tl, reald* ql,
				 reald* tr, reald* qr,
				 reald* t, reald* q );
};

inline
reald
cgTriangleStereo::point( qmdVectorRef& p2L, qmdVectorRef& p2R, qmdVectorRef& p3,
			 reald* residual )
{
    return Point( p2L(0), p2L(1), p2R(0), p2R(1), p3, residual );
}

#if 0
inline
void
cgTriangleStereo::ellipse( qmdVectorRef& mL, qmdMatrixRef& CL,
			 qmdVectorRef& mR, qmdMatrixRef& CR,
			 qmdVectorRef& m3out, qmdMatrixRef& C3out )
{
     ellipse( mL, CL, mR, CR, m3out, C3out );
}
#endif

inline
void
cgTriangleStereo::setLeftReferenceTransform
( reald tx, reald ty, reald tz, reald q0, reald q1, reald q2, reald q3 )
{
    tL[0] = tx;
    tL[1] = ty;
    tL[2] = tz;
    qL[0] = q0;
    qL[1] = q1;
    qL[2] = q2;
    qL[3] = q3;
    computeTriangle();
}

inline
void
cgTriangleStereo::setLeftBeta( reald b )
{
    BL() = b;
}

inline
void
cgTriangleStereo::setRightReferenceTransform
( reald tx, reald ty, reald tz, reald q0, reald q1, reald q2, reald q3 )
{
    tR[0] = tx;
    tR[1] = ty;
    tR[2] = tz;
    qR[0] = q0;
    qR[1] = q1;
    qR[2] = q2;
    qR[3] = q3;
    computeTriangle();
}

inline
void
cgTriangleStereo::setRightBeta( reald b )
{
    BR() = b;
}

inline
ostream&
cgTriangleStereo::print( ostream& os )
{
    qmdVectorRef( 3, tL ).print( os << "tL= " ) << endl;
    qmdVectorRef( 4, qL ).print( os << "qL= " ) << endl;
    qmdVectorRef( 3, tR ).print( os << "tR= " ) << endl;
    qmdVectorRef( 4, qR ).print( os << "qR= " ) << endl;
    Translation().print( os << "T= " ) << endl;
    Rotation().print( os << "R= " );
    os << "BL= " << BL() << endl;
    os << "BR= " << BR() << endl;
    return os;
}

#endif /* _cgTriangleStereo_H_ */
