// noErrorFunction.h++

#ifndef _noErrorFunction_H_
#define _noErrorFunction_H_

#include "QuickMathDouble.h"
#include <iostream.h>

class noErrorFunction
{
protected:
    qmdVector dy_return;
    qmdVector x_return;
    qmdMatrix J_return;
public:
    noErrorFunction()
      : dy_return(), x_return(), J_return() {}
    noErrorFunction( int ny, int nx, int ndx )
      : dy_return( ny ), x_return( nx ), J_return( ny, ndx ) {}
    void init( int ny, int nx, int ndx );
    int getNdy() { return dy_return.getLength(); }
    int getNx() { return x_return.getLength(); }
    int getNdx() { return J_return.getWidth(); }
    virtual const qmdVectorRef& operator()( const qmdVectorRef& x ) = 0;
    virtual const qmdMatrixRef& jacobian( const qmdVectorRef& x ) = 0;
    virtual const qmdVectorRef& add( const qmdVectorRef& x,
				    const qmdVectorRef& dx ) = 0;
};

#endif /* _noErrorFunction_H_ */
