// noIterativeReweightedLeastSquares.h++

#ifndef _noIterativeReweightedLeastSquares_H_
#define _noIterativeReweightedLeastSquares_H_

#include "noErrorFunction.h"
#include "QuickMathDouble.h"

class noIterativeReweightedLeastSquares
{
    noErrorFunction* erf;
    qmdVector x;
    qmdVector dy;
    qmdMatrix J;
    qmdMatrix Ri;
    qmdMatrix Pi;
    qmdMatrix JtRi;
    qmdMatrix tmp;
    qmdMatrix paren;
    qmdMatrix pseudoinverse;
    qmdVector dx;
    reald absTolerance;
    int verbose;
    int iterationLimit;
    static reald defaultAbsTolerance;

public:

    noIterativeReweightedLeastSquares();
    void init( noErrorFunction& a );
    const qmdVectorRef& estimate();
    // inline void setGradientTolerance( reald );
    inline void setAbsoluteTolerance( reald t ) { absTolerance = t; }
    inline void setState( qmdVectorRef& v ) { x.copy( v ); }
    inline void setVerbose( int v = 1 ) { verbose = v; }
    inline void setIterationLimit( int l ) { iterationLimit = l; }
};

typedef noIterativeReweightedLeastSquares noIRWLS;

#endif /* _noIterativeReweightedLeastSquares_H_ */
