// noYakkaYakka.c++

#include "noYakkaYakka.h"

void
noYakkaYakka::init( noErrorFunction& a )
{
    erf = &a;
    int nx = a.getNx();
    int n = a.getNdx();
    int p = a.getNdy();
    xP.set( nx );
    xE.set( nx );
    dX.set( n );
    dY.set( p );
    Pp.set( n, n );
    Pe.set( n, n );
    K.set( n, p );
    I.set( n, n );
    I.setIdentity();
    tempNxP.set( n, p );
    tempNxN.set( n, n );
    tempPxP.set( p, p );
    H.set( p, n );
    Phi.set( n, n );
    Phi.setIdentity();
    Q.set( n, n );
    R.set( p, p );
}

const qmdVectorRef&
noYakkaYakka::estimate()
{
    // ---- Kalman gain
    H.copy( erf -> jacobian( xP ) );
    tempNxP.setMultiplyT( Pp, H );
    tempPxP.setMultiply( H, tempNxP );
    tempPxP.setAddEq( R );
    tempPxP.setInvertEq();
    K.setMultiply( tempNxP, tempPxP );
    // ---- innovation
    // dY.copy( (*erf)( xP ) );
    dY.setNegate( (*erf)( xP ) );
    // yP.setMultiply( H, xP );
    // dY.setSubtract( y, yP );
    // ---- state estimate
    dX.setMultiply( K, dY );
    // xE.setAdd( xP, dX );
    xE.copy( erf -> add( xP, dX ) );
    // ---- error covariance for estimate
    tempNxN.setMultiply( K, H );
    tempNxN.setSubtract( I, tempNxN );
    Pe.setMultiply( tempNxN, Pp );
    //  does this work?
    // ---- state prediction
    // xP.setMultiply( Phi, xE );
    xP.copy( xE );
    // ---- error covariance for prediction
    tempNxN.setMultiply( Phi, Pe );
    Pp.setMultiplyT( tempNxN, Phi );
    Pp.setAddEq( Q );
    // Pp.setMultiplyT( tempNxN.setMultiply( Phi, Pe ), Phi ).setAddEq( Q );
    return xE;
}
