// noYakkaYakka.h++

#ifndef _noYakkaYakka_H_
#define _noYakkaYakka_H_

#include "noOptimizer.h"
#include "noErrorFunction.h"
#include "QuickMathDouble.h"

class noYakkaYakka : public noOptimizer
{
    noErrorFunction* erf;
    qmdVector xP;
    qmdVector xE;
    qmdVector dX;	
    // qmdVector yP;
    qmdVector dY;
    qmdMatrix Pp;
    qmdMatrix Pe;
    qmdMatrix K;
    qmdMatrix I;
    qmdMatrix tempNxP;
    qmdMatrix tempNxN;
    qmdMatrix tempPxP;
    int verbose;
 public:
    // Leave these public so the user can initialize or change them
    qmdMatrix H;
    qmdMatrix Phi;
    qmdMatrix Q;
    qmdMatrix R;
    
 public:
    void init( noErrorFunction& a );
    const qmdVectorRef& estimate();
    inline void setState( qmdVectorRef& x ) { xP.copy( x ); }
    inline void setCovariance( qmdMatrixRef& P ) { Pp.copy( P ); }
    const qmdMatrixRef& getCovariance() { return Pp; }
    inline void setVerbose( int v = 1 ) { verbose = v; }
};

#endif /* _noYakkaYakka_H_ */
