// qmGaussian.c++

#include "qmGaussian.h"

qmGaussian::qmGaussian( const int n )
  : qmGaussianRef( 0, 0 ), allocArray( 0 )
{
    set( n );
}

qmGaussian::qmGaussian( const qmVectorRef& mean_v, const qmMatrixRef& cov_m )
  : qmGaussianRef( 0, 0 ), allocArray( 0 )
{
    set( mean_v, cov_m );
}

qmGaussian&
qmGaussian::set( const int n )
{
    if( !( allocArray && 
	   getStorageSize( mean.getLength() ) == getStorageSize( n ) ) )
       {
	   if( allocArray )
	      delete [] allocArray;
	   allocArray = new real[ (n + 1)*n ];
	   mean.set( n, allocArray );
	   covariance.set( n, n, allocArray+n );
       }
    state = NOT_INITED;
    return *this;
}

qmGaussian&
qmGaussian::set( const qmVectorRef& mean_v, const qmMatrixRef& cov_m )
{
    set( mean_v.getLength() );
    mean.copy( mean_v );
    covariance.copy( cov_m );
    state = ( _testSingular() ) ? SINGULAR : NONSINGULAR;
    return *this;
}
