// qmGaussian.h++

#ifndef _qmGaussian_H_
#define _qmGaussian_H_

#include "QuickMath.h"
#include "qmGaussianRef.h"

class qmGaussian : public qmGaussianRef
{
    real* allocArray;  // n + n*n = (n+1)n
public:
    qmGaussian()
      : qmGaussianRef(), allocArray( 0 ) {}
    qmGaussian( const int n );
    qmGaussian( const qmVectorRef&, const qmMatrixRef& );
    ~qmGaussian() { if (allocArray) delete [] allocArray; } 
    qmGaussian& set( const int n );
    qmGaussian& set( const qmVectorRef&, const qmMatrixRef& );
};

#endif /* _qmGaussian_H_ */
