// qmGaussianInv.c++

#include "qmGaussianInv.h"

qmGaussianInv::qmGaussianInv( const int n )
  : qmGaussianInvRef( 0, 0 ), allocArray( 0 )
{
    set( n );
}

qmGaussianInv::qmGaussianInv
( const qmVectorRef& mean_v, const qmMatrixRef& invcov_m )
  : qmGaussianInvRef( 0, 0 ), allocArray( 0 )
{
    set( mean_v, invcov_m );
}

qmGaussianInv&
qmGaussianInv::set( const int n )
{
    if( !( allocArray && 
	   getStorageSize( mean.getLength() ) == getStorageSize( n ) ) )
       {
	   if( allocArray )
	      delete [] allocArray;
	   allocArray = new real[ (n + 1)*n ];
	   mean.set( n, allocArray );
	   invCovariance.set( n, n, allocArray+n );
       }
    state = NOT_INITED; // ??
    return *this;
}

qmGaussianInv&
qmGaussianInv::set( const qmVectorRef& mean_v, const qmMatrixRef& invcov_m )
{
    set( mean_v.getLength() );
    mean.copy( mean_v );
    invCovariance.copy( invcov_m );
    testSetSingular();
    // state = ( _testSingular() ) ? SINGULAR : NONSINGULAR;
    return *this;
}
