// qmKMeans.h++

#ifndef _qmKMeans_H_
#define _qmKMeans_H_

#include "QuickMath.h"
#include <iostream.h>

class qmKMeans
{
    int dimension;
    int clusterCount;
    int* clusterValid;
    qmVectorRef* clusters;
    real* clusterData;
    int sampleCount;
    int* sampleMap;
    real* sampleWeights;
    qmVectorRef* samples;
    real* sampleData;

    int inited() { return( dimension && clusterCount && sampleCount ); }
    int reclassify();
    void updateClusterMean( int i);
    int findClosestClass( qmVectorRef& );
    ostream& printClassification( ostream& os );
public:
    qmKMeans()
      : dimension(0),
	clusterCount(0),
	clusterValid(0),
	clusters(0),
	clusterData(0),
	sampleCount(0),
	sampleMap(0),
	samples(0),
	sampleWeights(0),
	sampleData(0)
    {}
    ~qmKMeans();
    void setDimension( int );
    void setClusterCount( int );
    void setSampleCount( int );
    void setClusterMean( int, const qmVectorRef& );
    void setSample( int, const qmVectorRef& );
    void setSampleWeight( int, real );
    void cluster();
    int getClusterOfSample( int i ) { return sampleMap[i]; }
    const qmVectorRef& getClusterMean( int i ) { return clusters[i]; }
    int getClusterValid( int i ) { return clusterValid[i]; }
    ostream& print( ostream& );
};

#endif /* _qmKMeans_H_ */
