// qmStatistics.c++

#include "qmStatistics.h"

int
qmStatistics::invert( const qmGaussianRef& in, qmGaussianInvRef& out )
{
    if( in.isSingular() )
       return 1;
    qmMatrix m( in.getCovariance() );
    m.setInvertEq();
    out.set( in.getMean(), m );
    return 0;
}

int
qmStatistics::invert( const qmGaussianInvRef& in, qmGaussianRef& out )
{
    if( in.isSingular() )
       return 1;
    qmMatrix m( in.getInvCovariance() );
    m.setInvertEq();
    out.set( in.getMean(), m );
    return 0;
}
