// qmdGaussian.c++

#include "qmdGaussian.h"

qmdGaussian::qmdGaussian( const int n )
  : qmdGaussianRef( 0, 0 ), allocArray( 0 )
{
    set( n );
}

qmdGaussian::qmdGaussian( const qmdVectorRef& mean_v, const qmdMatrixRef& cov_m )
  : qmdGaussianRef( 0, 0 ), allocArray( 0 )
{
    set( mean_v, cov_m );
}

qmdGaussian&
qmdGaussian::set( const int n )
{
    if( !( allocArray && 
	   getStorageSize( mean.getLength() ) == getStorageSize( n ) ) )
       {
	   if( allocArray )
	      delete [] allocArray;
	   allocArray = new reald[ (n + 1)*n ];
	   mean.set( n, allocArray );
	   covariance.set( n, n, allocArray+n );
       }
    state = NOT_INITED;
    return *this;
}

qmdGaussian&
qmdGaussian::set( const qmdVectorRef& mean_v, const qmdMatrixRef& cov_m )
{
    set( mean_v.getLength() );
    mean.copy( mean_v );
    covariance.copy( cov_m );
    state = ( _testSingular() ) ? SINGULAR : NONSINGULAR;
    return *this;
}
