// qmdGaussian.h++

#ifndef _qmdGaussian_H_
#define _qmdGaussian_H_

#include "QuickMathDouble.h"
#include "qmdGaussianRef.h"

class qmdGaussian : public qmdGaussianRef
{
    reald* allocArray;  // n + n*n = (n+1)n
public:
    qmdGaussian()
      : qmdGaussianRef(), allocArray( 0 ) {}
    qmdGaussian( const int n );
    qmdGaussian( const qmdVectorRef&, const qmdMatrixRef& );
    ~qmdGaussian() { if (allocArray) delete [] allocArray; } 
    qmdGaussian& set( const int n );
    qmdGaussian& set( const qmdVectorRef&, const qmdMatrixRef& );
};

#endif /* _qmdGaussian_H_ */
