// qmdGaussianInv.c++

#include "qmdGaussianInv.h"

qmdGaussianInv::qmdGaussianInv( const int n )
  : qmdGaussianInvRef( 0, 0 ), allocArray( 0 )
{
    set( n );
}

qmdGaussianInv::qmdGaussianInv
( const qmdVectorRef& mean_v, const qmdMatrixRef& invcov_m )
  : qmdGaussianInvRef( 0, 0 ), allocArray( 0 )
{
    set( mean_v, invcov_m );
}

qmdGaussianInv&
qmdGaussianInv::set( const int n )
{
    if( !( allocArray && 
	   getStorageSize( mean.getLength() ) == getStorageSize( n ) ) )
       {
	   if( allocArray )
	      delete [] allocArray;
	   allocArray = new reald[ (n + 1)*n ];
	   mean.set( n, allocArray );
	   invCovariance.set( n, n, allocArray+n );
       }
    state = NOT_INITED; // ??
    return *this;
}

qmdGaussianInv&
qmdGaussianInv::set( const qmdVectorRef& mean_v, const qmdMatrixRef& invcov_m )
{
    set( mean_v.getLength() );
    mean.copy( mean_v );
    invCovariance.copy( invcov_m );
    testSetSingular();
    // state = ( _testSingular() ) ? SINGULAR : NONSINGULAR;
    return *this;
}
