// qmdGaussianInv.h++

#ifndef _qmdGaussianInv_H_
#define _qmdGaussianInv_H_

#include "QuickMathDouble.h"
#include "qmdGaussianInvRef.h"

class qmdGaussianInv : public qmdGaussianInvRef
{
    reald* allocArray;  // n + n*n = (n+1)n
public:
    qmdGaussianInv()
      : qmdGaussianInvRef(), allocArray( 0 ) {}
    qmdGaussianInv( const int n );
    qmdGaussianInv( const qmdVectorRef&, const qmdMatrixRef& );
    ~qmdGaussianInv() { if (allocArray) delete [] allocArray; } 
    qmdGaussianInv& set( const int n );
    qmdGaussianInv& set( const qmdVectorRef&, const qmdMatrixRef& );
};

#endif /* _qmdGaussianInv_H_ */
