// qmdKMeans.h++

#ifndef _qmdKMeans_H_
#define _qmdKMeans_H_

#include "QuickMathDouble.h"
#include <iostream.h>

class qmdKMeans
{
    int dimension;
    int clusterCount;
    int* clusterValid;
    qmdVectorRef* clusters;
    reald* clusterData;
    int sampleCount;
    int* sampleMap;
    reald* sampleWeights;
    qmdVectorRef* samples;
    reald* sampleData;

    int inited() { return( dimension && clusterCount && sampleCount ); }
    int reclassify();
    void updateClusterMean( int i);
    int findClosestClass( qmdVectorRef& );
    ostream& printClassification( ostream& os );
public:
    qmdKMeans()
      : dimension(0),
	clusterCount(0),
	clusterValid(0),
	clusters(0),
	clusterData(0),
	sampleCount(0),
	sampleMap(0),
	samples(0),
	sampleWeights(0),
	sampleData(0)
    {}
    ~qmdKMeans();
    void setDimension( int );
    void setClusterCount( int );
    void setSampleCount( int );
    void setClusterMean( int, const qmdVectorRef& );
    void setSample( int, const qmdVectorRef& );
    void setSampleWeight( int, reald );
    void cluster();
    int getClusterOfSample( int i ) { return sampleMap[i]; }
    const qmdVectorRef& getClusterMean( int i ) { return clusters[i]; }
    int getClusterValid( int i ) { return clusterValid[i]; }
    ostream& print( ostream& );
};

#endif /* _qmdKMeans_H_ */
