// qmdStatistics.c++

#include "qmdStatistics.h"

int
qmdStatistics::invert( const qmdGaussianRef& in, qmdGaussianInvRef& out )
{
    if( in.isSingular() )
       return 1;
    qmdMatrix m( in.getCovariance() );
    m.setInvertEq();
    out.set( in.getMean(), m );
    return 0;
}

int
qmdStatistics::invert( const qmdGaussianInvRef& in, qmdGaussianRef& out )
{
    if( in.isSingular() )
       return 1;
    qmdMatrix m( in.getInvCovariance() );
    m.setInvertEq();
    out.set( in.getMean(), m );
    return 0;
}
