// $CopyrightHeader$

// Copyright (C) 1996 by Ali Azarbayejani and the Massachusetts
// Institute of Technology
// Copyright (C) 1997 by Christopher R. Wren and the Massachusetts
// Institute of Technology
//
// COMMERCIAL DISCLAIMER:
//
// This software is intended for research purposes only and contains
// unlicensed software, in original and modified forms, from various
// sources including the Free Software Foundation.	These programs
// shall not be used, rewritten, or adapted as the basis of a
// commercial software or hardware product without first obtaining
// appropriate licenses from the owners of the original software
// copyrights.
//
// In the case of copyrighted software fragments obtained from the
// Free Software Foundation: you can redistribute it and/or modify it
// under the terms of the GNU Library General Public License as
// published by the Free Software Foundation.  This software is
// distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.	See the GNU Library General
// Public License for more details.  You should have received a copy
// of the GNU Library General Public License and the GNU General
// Public License along with this software; if not, write to the Free
// Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.


// MIT COPYRIGHT:
// 
// Copyright 1995  by  the	Massachusetts Institute  of Technology. 	All  
// rights reserved.
// 
// Developed	by Ali Azarbayejani at the Media Laboratory, MIT,
// Cambridge, Massachusetts.
// 
// Permission to use, copy,  or modify this software and	its documentation
// for	educational  and	research purposes only and without fee	is hereby
// granted, provided	that this copyright notice and the original authors's
// names appear  on all copies and supporting documentation.	If individual
// files are	separated from	this	distribution directory	structure, this
// copyright notice must be included.  For any other uses of this software,
// in original or  modified form, including but not limited to distribution
// in whole or in  part, specific  prior permission  must be	obtained from
// MIT.  These programs shall not  be  used, rewritten, or	adapted as	the
// basis	of	a commercial	software	or	hardware product	without first
// obtaining appropriate licenses  from MIT.	MIT. makes no representations
// about the suitability of this	software for any purpose.  It is provided
// "as is" without express or implied warranty.

// ffinder.c++

#include "vlImage.h"
#include "glDisplay.h"

#include "BlobMan.h"
#include "Person.h"
#include "Prior.h"
#include "FfFile.h"
#include "qmTime.h"
#include "rffinderServer.h"
#include <stdio.h>
#include <windows.h>
#include <iostream.h>
#include <fstream.h>

void main( int argc, char *argv[] )
{
		int verbose = 1;
		int zoom = 2;
		int width;
		int height;
    int card = 0;
		int serveMode = 1;
		int processMode = 1;
		int undumpMode = 0;
		int displayMode = 1;
		int PriorsMode = 0;
		int displayPointsMode = 1;
		int displayPriorsMode = 0;
		int displayBlobsMode = 0;
		int displayQuickPoints = 1;
		int howslowMode = 0;
		int grabMode = 0;
		char* colorFile = 0;
		char* libPath = ".";
    		int initMode = 0;
		char* ffFilename = "right_camera.ff";
    vlImage grabber;
/*
		ParseRuleFlag( 'v', verbose, 1, "Verbose mode" );
		ParseRuleFlag( 'v', BlobMan::verbose, 1, "Verbose mode" );
		ParseRuleTag( "vb", Blob::verbose, 1, "Verbose mode" );
		ParseRuleTag( "serve", serveMode, 1, "serve" );
		ParseRuleTag( "noproc", processMode, 0, "do not process" );
		ParseRuleTag( "nodpy", displayMode, 0, "do not display" );
		ParseRuleTag( "blobs", displayBlobsMode, 1, "display blobs" );
		ParseRuleTag( "priors", PriorsMode, 1, "display priors" );
		ParseRuleTag( "pdpy", displayPriorsMode, 1, "display priors" );
		ParseRuleTag( "quickpts", displayQuickPoints, 1, "display quick points" );
		ParseRuleTag( "howslow", howslowMode, 1, "howslow mode" );
		ParseRuleTag( "grab", grabMode, 1, "grab mode" );
		ParseRuleTag( "indy", aord, (int) vlImage::INDYANALOG, "Indy SVideo" );
		ParseRuleTag( "O2S",	aord, (int) vlImage::O2SVIDEO, "O2 SVideo" );
		ParseRuleTag( "O2C",	aord, (int) vlImage::O2COMPOSITE, "O2 Composite" );
		ParseRuleTaggedArg( "color", colorFile, "color stats file", "filename" );
		ParseRuleTag( "c", Blob::mode, (int)Blob::WOOHOO, "cell mode, woohoo" );
		ParseRuleTaggedArgInt( "c", BlobMan::cellWidth, "cell width", "w" );
		ParseRuleTaggedArgInt( "c", BlobMan::cellHeight, "cell height", "h" );
		ParseRuleTaggedArgFloat( "c", Cell::classifyPercentThresh, "thresh", 
					 "percent" );
		ParseRuleTaggedArgInt( "c", BlobMan::cullMinBlob, "medium min blob", "N" );
		ParseRuleTag( "init", initMode, 1, "init only mode" );

		ParseRuleTaggedArg( "config", ffFilename, "filename of config data",
			"filename" );
		ParseRuleTag( "nocrash",	BlobMan::crashRatio, (real) 2.0,
					 "ignore blob collisions " );
		ParseRuleTaggedArgFloat( "crash", BlobMan::crashRatio, 
					 "minimum crash pixels for collide", "ratio" );
		ParseRuleTaggedArgFloat( "mthresh", Pixel::mutualThresh, 
					 "threshold for overlap", "ratio" );
		ParseRuleTaggedArg( "path", libPath, "library path", "path" );
		ParseRuleTaggedArgInt( "et", BlobMan::existenceThresh, 
				 "existence threshold", "number" );
		if( Parse::ParseCmdLine( argc, argv ) )
			 Parse::Usage( argv[0] ), exit(1);
       */

		FfFile ffFile;
		ffFile.setPath( libPath );
    if( ffFile.scan( ffFilename ) ){
      printf("Couldn't find  %s\n",ffFilename);
			 exit( 1 );
    }
		if( grabMode ){
		 vliRGBImageRef iref;
		 grabber.init( card, zoom, vlImage::RGB );
		// sginap( 50 );
		 grabber.grab( iref );

   		width = iref.getWidth();
  		height = iref.getHeight();

     glDisplay gldpy;
		  if( displayMode ) gldpy.init( height, width );

	    //vliRGBImage rgbImage( width, height );
	
      for(int i=0;i<50;i++){
        grabber.grab( iref );
        if( displayMode ) 
        {
        //  iref._tobgra( rgbImage.getPixelData() );
          gldpy = (unsigned long *) iref.getPixelPtr(0);
        }
      }
      ofstream os("image.raw",ios::out|ios::binary);
		 iref.writeRawRGB( os );
		 grabber.close();
		 cerr << "wrote image, w= " << iref.getWidth() 
		<< ", h= " << iref.getHeight() << endl;
		 return;
		}

    rffinderServer server;
		if( serveMode ){
		 server.init();
		 server.start();
	  }
    
		vliRGBImageRef iref;
		grabber.init( card, zoom, vlImage::RGB);
		grabber.grab( iref );
		width = iref.getWidth();
		height = iref.getHeight();
    cerr << "Height = " << height << endl;
    cerr << "Width = " << width << endl;
		//vliRGBImage rgbImage( width, height );
		glDisplay gldpy;
		if( displayMode ) gldpy.init( height, width );
		
		BlobMan blobMan;
		blobMan.init( width, height );
		if( initMode )
			 blobMan.initOnly();
		blobMan.setFleshStats( qmVectorRef( 3, ffFile.colorMean ),
				 qmMatrixRef( 3, 3, ffFile.colorInvCov ) );
    
		if (ffFile.pixel_thresh > .01)
			 Pixel::thresh2 = ffFile.pixel_thresh;

    Pixel::thresh2 = 9;
		cerr << "Pixel::thresh2 = " << Pixel::thresh2 << endl;

		//HowSlow howSlow(30);
		Person person;
		Prior prior( width, height );
		Prior nullprior( width, height );
		int processStatus = 0;
    
    for( int frameCount = 0;; frameCount++ ){
      if(serveMode)
        if(server.quitFlag) {
          //Sleep(1000);
          grabber.close();
          gldpy.close();
          MatroxEnvironment::close();
          raise(SIGTERM);
//          Sleep(1000);
          return;
        }
//      if( howslowMode )
//        howSlow.sample();
      if( !undumpMode )
        grabber.grab( iref );
  
      if( serveMode ) 
      {
        prior.set(server.copy_priors());
      }
      if( rffinderServer::forceInit )
      {
        rffinderServer::forceInit = 0;
        blobMan.setMode( blobMan.INIT_MODE );
      }
      if( processMode )
      {
        if( PriorsMode ) 
          processStatus = blobMan.process( iref , prior );
        else
          processStatus = blobMan.process( iref , nullprior );
      }

//      gettimeofday( &tv );
      qmTime qmtime;

      if( blobMan.INIT_MODE == blobMan.getMode() || processStatus )
        person.init( frameCount, qmtime.tv.tv_sec, qmtime.tv.tv_usec,
        blobMan.getPersonExists() );
      else
        person.set( frameCount, qmtime.tv.tv_sec, qmtime.tv.tv_usec, 
        blobMan.getPersonExists(),
        blobMan.getBlobMean_Pics( blobMan.HEAD ),
        blobMan.getBlobMean_Pics( blobMan.LHAND ),
        blobMan.getBlobMean_Pics( blobMan.RHAND ) );
/*
      cerr << "Person Exists = " << blobMan.getPersonExists() << endl;
      cerr << "Head = ";
      blobMan.getBlobMean_Pics( blobMan.HEAD ).print(cerr);
      cerr << endl;
      
      cerr << "LHand = ";
      blobMan.getBlobMean_Pics( blobMan.LHAND).print(cerr);
      cerr << endl;

      cerr << "RHand= ";
      blobMan.getBlobMean_Pics( blobMan.RHAND).print(cerr);
      cerr << endl;
*/
      if( displayMode ) 
      {
        //iref._tobgra( rgbImage.getPixelData() );
        //vlImage::yuvToRgb(iref,rgbImage);
        if( displayBlobsMode )
          blobMan.drawBlobs( iref );
        else if( displayPointsMode )
          blobMan.drawPoints( iref );		 
        if( displayPriorsMode) 
          prior.draw( iref ); 	 
        if( displayQuickPoints && 
          blobMan.INIT_MODE != blobMan.getMode() )
        {
          static vliRGBPixel white( 255, 255, 255 );
          float qp[12];
          memcpy( qp, blobMan.getQuickPoints(), 12*sizeof(float) );
          for( int i = 0; i < 6; i++ )
            iref.drawCross( qp[2*i], qp[2*i+1], white );
        }
/*
        // Draw classification
          float maha2_tmp;

          real rgb[3];
          for(int i=0;i<iref.getPixelCount();i++){
            vliRGBPixel &p = iref.getPixel(i);
            rgb[0] = p.r; rgb[1] = p.g; rgb[2] = p.b;
            qmVectorRef x(3,rgb);
            maha2_tmp = blobMan.fleshClass.getMahalanobisSquare( x );

            if( maha2_tmp < Pixel::thresh2 ){
              p.r = 255;
              p.g = 83;
              p.b = 83;
            }
          }
          */
          gldpy = (unsigned long *) iref.getPixelPtr(0);
      }

      if( serveMode ) 
      {
        server.copy( person.get() );
      }
      
      //sginap(1);
      //Sleep(1);
   } 

   cerr << "closing..." << endl;
    grabber.close();
}
