// IvStereoCamera.h++

#ifndef _IvStereoCamera_H_
#define _IvStereoCamera_H_

#include "IvCamera.h++"
#include "Iv3DViewer.h++"

class IvStereoCamera : public Iv3DViewer
{
    void initialize( float, float, float, float, float,
		     float, float, float, float, Widget, int w, int h );
    static void selectCB( void*, SoPath* );
    static void deselectCB( void*, SoPath* );
    static void keypressCB( void*, SoEventCallback* );

    Widget form;

public:

    IvCamera* leftCamera;
    IvCamera* rightCamera;
    int viewHeight;

public:

    IvStereoCamera( float bl, float br,
		    float tx, float ty, float tz,
		    float q0, float q1, float q2, float q3 );
    IvStereoCamera( Widget = NULL, int w = 240, int h = 180,
		    int vh = 340 );
    ~IvStereoCamera();
    inline void setKeyCB( int (*)(void*, SoEventCallback*), void* = 0 );
    inline SoPerspectiveCamera* get3DCamera(){return Iv3DViewer::getCamera();}
    void getRLRefTransform( float&, float&, float&,
			    float&, float&, float&, float& );
    inline Widget getWidget() { return form; }
    void handle();
    IvCamera* getCamera( int i ) { return( (i) ? rightCamera : leftCamera ); }
};

void
IvStereoCamera::setKeyCB( int (*fn)(void*, SoEventCallback* ),
			  void* data )
{
    Iv3DViewer::setKeyCB( fn, data );
    leftCamera -> setKeyCB( fn, data );
    rightCamera -> setKeyCB( fn, data );
}

#endif /* _IvStereoCamera_H_ */
