// PurplePoint.c++

#include "PurplePoint.h"

SoSphere* PurplePoint::geometry = 0;

PurplePoint::PurplePoint()
  : root( new SoSeparator ),
    material( new SoMaterial ),
    xform( new SoTransform )
{
    if( !geometry )
       {
	   SoSphere* tmp = new SoSphere;
	   tmp -> ref();
	   tmp -> radius = .1;
	   geometry = tmp;
       }
    root -> ref();
    root -> addChild( xform );
    root -> addChild( material );
    root -> addChild( geometry );
    xform -> translation.setValue( 0, 0, 0 );
    material -> diffuseColor.setValue( .65, .15, 1 );
    material -> ambientColor.setValue( .65, .15, 1 );
}

void
PurplePoint::set( double* xyz )
{
    xform -> translation.setValue( xyz[0], xyz[1], xyz[2] );
}

void
PurplePoint::setColor( float r, float g, float b )
{
    material -> diffuseColor.setValue( r, g, b );
    material -> ambientColor.setValue( r, g, b );
}
