// SffinderServer.c++

#include "SffinderServer.h"

sffPerson SffinderServer::homey;
sffPersonPlus SffinderServer::homeyPlus;
int SffinderServer::homeyLock = 0;
int SffinderServer::undumpFlag = 0;
int SffinderServer::sleepFlag = 0;

// ------------------------------------------------
// Server-side stubs for the sffinder 

int *
sffquit_1(void *, struct svc_req *)
{
    static int retval = 0;
    // cleanup();
    return &retval;
}

sffPerson *
sffgetperson_1(void *, struct svc_req *)
{
    static sffPerson localHomey;
    while( SffinderServer::homeyLock )
       sginap(0);
    SffinderServer::homeyLock = 1;
    localHomey = SffinderServer::homey;
    SffinderServer::homeyLock = 0;
    return &localHomey;
}

sffPersonPlus *
sffgetpersonplus_1(void *, struct svc_req *)
{
    static sffPersonPlus localHomey;
    while( SffinderServer::homeyLock )
       sginap(0);
    SffinderServer::homeyLock = 1;
    localHomey = SffinderServer::homeyPlus;
    SffinderServer::homeyLock = 0;
    return &localHomey;
}

sffPersonPlus *
sffgetnextpersonplus_1( int *tlast, struct svc_req * )
{
    static sffPersonPlus localHomeyPlus;
    // while( SffinderServer::homeyPlus.frameNumber <= *tlast )
    while( SffinderServer::homeyPlus.frameNumber == *tlast )
       sginap( 1 );
    while( SffinderServer::homeyLock )
       sginap( 0 );
    SffinderServer::homeyLock = 1;
    localHomeyPlus = SffinderServer::homeyPlus;
    SffinderServer::homeyLock = 0;
    return &localHomeyPlus;
}

sffPerson *
sffgetnextperson_1( int *tlast, struct svc_req * )
{
    static sffPerson localHomey;
    while( SffinderServer::homey.frameNumber == *tlast )
       sginap( 2 );
    while( SffinderServer::homeyLock )
       sginap( 0 );
    SffinderServer::homeyLock = 1;
    localHomey = SffinderServer::homey;
    SffinderServer::homeyLock = 0;
    return &localHomey;
}

int *
sffundumpnext_1(void *, struct svc_req *)
{
    static int rvalue = 0;
    SffinderServer::undumpFlag = 1;
    return &rvalue;
}

int *
sffgetpersonexists_1( void *, struct svc_req * )
{
    static int rvalue = 0;
    rvalue = SffinderServer::homeyPlus.personExists;
    return &rvalue;
}

SffinderServer::SffinderServer()
{
    init();
}

#include <limits.h>
#include <sys/types.h>
#include <sys/prctl.h>
#include <sys/schedctl.h>

void
SffinderServer::init()
{
    schedctl( NDPRI, child_pid, NDPHIMAX );
    homey.leftHand.valid = 0;
    homey.rightHand.valid = 0;
    homey.head.valid = 0;
    homeyPlus.head.valid = 0;
    homeyPlus.leftHand.valid = 0;
    homeyPlus.rightHand.valid = 0;
}

void
SffinderServer::copy( const sffPersonPlus& spp )
{
    while( homeyLock )
       sginap( 0 );
    homeyLock = 1;
    homeyPlus = spp;
    homeyLock = 0;
}

void
SffinderServer::copy( const sffPerson& spp )
{
    while( homeyLock )
       sginap( 0 );
    homeyLock = 1;
    homey = spp;
    homeyLock = 0;
}

void *
sffsleep_1( void *, struct svc_req * )
{
    int garbage;
    SffinderServer::sleepFlag = 1;
    return &garbage;
}
    
void *
sffwakeup_1( void *, struct svc_req * )
{
    int garbage;
    kill( getppid(), SIGUSR1 );
    return &garbage;

}


