// $CopyrightHeader$

// Copyright (C) 1996 by Ali Azarbayejani and the Massachusetts
// Institute of Technology
//
// COMMERCIAL DISCLAIMER:
//
// This software is intended for research purposes only and contains
// unlicensed software, in original and modified forms, from various
// sources including the Free Software Foundation.  These programs
// shall not be used, rewritten, or adapted as the basis of a
// commercial software or hardware product without first obtaining
// appropriate licenses from the owners of the original software
// copyrights.
//
// In the case of copyrighted software fragments obtained from the
// Free Software Foundation: you can redistribute it and/or modify it
// under the terms of the GNU Library General Public License as
// published by the Free Software Foundation.  This software is
// distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library General
// Public License for more details.  You should have received a copy
// of the GNU Library General Public License and the GNU General
// Public License along with this software; if not, write to the Free
// Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.


// MIT COPYRIGHT:
// 
// Copyright 1995  by  the  Massachusetts Institute  of Technology.   All  
// rights reserved.
// 
// Developed  by Ali Azarbayejani at the Media Laboratory, MIT,
// Cambridge, Massachusetts.
// 
// Permission to use, copy,  or modify this software and  its documentation
// for  educational  and  research purposes only and without fee  is hereby
// granted, provided  that this copyright notice and the original authors's
// names appear  on all copies and supporting documentation.  If individual
// files are  separated from  this  distribution directory  structure, this
// copyright notice must be included.  For any other uses of this software,
// in original or  modified form, including but not limited to distribution
// in whole or in  part, specific  prior permission  must be  obtained from
// MIT.  These programs shall not  be  used, rewritten, or  adapted as  the
// basis  of  a commercial  software  or  hardware product  without first
// obtaining appropriate licenses  from MIT.  MIT. makes no representations
// about the suitability of this  software for any purpose.  It is provided
// "as is" without express or implied warranty.

// noErrorFunction.h++

#ifndef _noErrorFunction_H_
#define _noErrorFunction_H_

#include "QuickMath/QuickMath.h"
#include <iostream.h>

class noErrorFunction
{
protected:
    qmVector dy_return;
    qmVector x_return;
    qmMatrix J_return;
public:
    noErrorFunction()
      : dy_return(), x_return(), J_return() {}
    noErrorFunction( int ny, int nx, int ndx )
      : dy_return( ny ), x_return( nx ), J_return( ny, ndx ) {}
    void init( int ny, int nx, int ndx );
    int getNdy() { return dy_return.getLength(); }
    int getNx() { return x_return.getLength(); }
    int getNdx() { return J_return.getWidth(); }
    virtual const qmVectorRef& operator()( const qmVectorRef& x ) = 0;
    virtual const qmMatrixRef& jacobian( const qmVectorRef& x ) = 0;
    virtual const qmVectorRef& add( const qmVectorRef& x,
				    const qmVectorRef& dx ) = 0;
};

#endif /* _noErrorFunction_H_ */
