// PersonPlus.h++

#ifndef _PersonPlus_H_
#define _PersonPlus_H_

//#include <rpc/rpc.h>
//#include "sffinder_svc.h"
//#include "ffinder_clnt.h"
#include "ffinder_pc.h"
#include "sffinder.h"
#include "QuickMathDouble.h"
// #include "Time/Time.h++"
#include "qmdTime.h"

class PersonPlus
{
    inline void nextInRing_timed();
    inline void nextInRing_force();
    inline void prevInRing_force();

    sffPersonPlus* person;
    sffPersonPlus* ring;
    int ringLength;
    int ringAllocLength;
//     Time time_now;
//     Time time_prev;
//     Time dt_now;
//     Time dt_k;
    qmdTime time_now;
    qmdTime time_prev;
    qmdTime dt_now;
    qmdTime dt_k;
    sffPerson hands;
    int handWhichAxis[2];
    int handMinus[2];
    reald quickPoints[ 3*6 ];

    int valid[3];
    qmdVector* yArray[3];
    int yInit;
    qmdVectorRef yRefArray[3];
    int ySync; // y is consistent with "person"
    qmdVectorRef tRefArray[3];
    qmdUnitQuaternionRef qRefArray[3];
    qmdVectorRef lRefArray[3];
    qmdVectorRef tWRefArray[3];
    qmdUnitQuaternionRef qWRefArray[3];
    qmdVectorRef lWRefArray[3];
    static ostream& alert( char* fn, char* msg );
    static void error( char* fn, char* msg );

    reald lastImagePos[2][3][2];
    reald moveMags[6];
    reald moveMag;

public:
    static int maxRingLength;

    PersonPlus();

    enum { Forward, Backward };
    void initRing( int n = maxRingLength );
    istream& readRing( istream& );
    int readRing( char* filename );
    ostream& writeRing( ostream& );
    int writeRing( char* filename );
    int dump();
    int undump_force( int dir = Forward );
    int undump_timed();

    const sffPersonPlus& get() { return *person; }
    enum { HEAD=0, LEFTHAND=1, RIGHTHAND=2 };
    void set2( const ffPerson& left, const ffPerson& right );
    qmdVectorRef* getYArray();
    int* getValid();
    qmdVectorRef* getTArray();
    qmdUnitQuaternionRef* getQArray();
    qmdVectorRef* getLArray();
    qmdVectorRef* getTWArray();
    qmdUnitQuaternionRef* getQWArray();
    qmdVectorRef* getLWArray();
    // qmdVectorRef* getCArray();
    inline void setStamp( long n, long s, long us );
    void findHands();
    const sffPerson& getHands() const { return hands; }
//     const qmdVectorRef& getLeftHand();
//     const qmdVectorRef& getRightHand();
    int* getHandWhichAxis() { return handWhichAxis; }
    int* getHandMinus() { return handMinus; }

    enum { NoPerson, ValidPerson, InvalidPerson };
    int personState;
    int partState[3];
    void setState();
    inline int getState() { return personState; }
    inline int getState(int i) { return partState[i]; }

    inline int getFrameNumber() { return person->frameNumber; }
    inline int personExists() { return person->personExists; }
    inline int personFullyValid();

    static reald moveThresh;
    inline int moved2D() { return( moveMag > moveThresh ); }

    float* correspond;
    float* getRingCorr( int& n );
    reald* getQPArray() { return quickPoints; }
    int getRingLength() { return ringLength; }
};

inline
void
PersonPlus::setStamp( long n, long s, long us )
{
    person -> frameNumber = n;
    person -> timestampSec = s;
    person -> timestampUsec = us;
}

inline
int
PersonPlus::personFullyValid()
{
    getValid();
    if( valid[0] && valid[1] && valid[2] )
       return 1;
    return 0;
}

#endif /* _PersonPlus_H_ */
