// SffFile.h++

#ifndef _SffFile_H_
#define _SffFile_H_

#include <fstream.h>
#include <iostream.h>

class SffFile
{
    inline istream& scan_hosts( istream& );
    inline istream& scan_stereo( istream& );
    inline istream& scan_view( istream& );
    inline istream& scan_world( istream& );
    char* pathname;
    static ostream& alert( char* fn, char* msg );
    static void error( char* fn, char* msg );
    
public:
    char ffinder_left[256];
    char ffinder_right[256];
    double stereo_t[3];
    double stereo_q[4];
    double stereo_bl;
    double stereo_br;
    double view_t[3];
    double view_q[4];
    double view_heightAngle;
    double world_t[3];
    double world_r[9];
    double world_scale;

    SffFile() 
      : pathname( "." ) {}
    inline void setPath( char* s ) { pathname = s; }
    istream& scan( istream& );
    int scan( char* );
    ostream& print( ostream& );
    int print( char* );
};

#endif /* _SffFile_H_ */
