// sffinder.c++
//#include "Parse/Parse.h++"
//#include "FfinderClient.h++"
//#include "SffinderServer.h++"

#include "vlImage.h"
#include "glDisplay.h"

#include "ComputeGeometry.h"
//#define Time XXXTime
//#include "PersonViewer.h"
//#undef Time
#include "PersonPlus.h"
//#include "Useless/HowSlow.h++"
#include "SffFile.h"
#include "qmTime.h"
#include "SffinderServer.h"
#include "lffinderClient.h"
#include "rffinderClient.h"
#include <direct.h>
#include <stdio.h>
#include <stdlib.h>
#include <windows.h>

static
inline
void
setState( PersonPlus& pp, ComputeGeometry& cg, int* perstate )
{
  #if 0
  pp.setState( ffinderClient.getLeftState(),
    ffinderClient.getRightState() );
  #endif
  pp.setState();
  for( int i = 0; i < 3; i++ )
  {
    switch( pp.getState() )
    {
    case PersonPlus::NoPerson:
      cg.setMode( i, cg.NOMODE );
      break;
    case PersonPlus::ValidPerson:
      switch( perstate[i] )
      {
      case PersonPlus::NoPerson: cg.setMode( i, cg.BLOB ); break;
      default: cg.setMode( i, cg.YAKKA );
      }
      break;
      case PersonPlus::InvalidPerson:
        break;
    }
    perstate[i] = pp.getState( i );
  
  }
}

static void
#ifdef IRIX64
ignore(int)
#else
ignore(...)
#endif
{
    return;
}

char dumpFilename1[100] = "x.dump";
char dumpFilename2[100] = "y.dump";

void
main( int argc, char *argv[] )
{
    int calibrateFlag = 0;
    int ffinderMode = 1;
    int undumpMode = 0;
    int dumpMode = 0;
    int collectMode = 0;
    int serveMode = 1;
    int displayMode = 0;
    char* dumpFilename = 0; 
    int dumpNumber = 0;
    int dumpSkip = 0;
    int syncMode = 0;
    int noShitDump = 0;
    int moveDump = 0;

    int width = 280;
    int height = 210;
    int x0 = 35;
    int y0 = -80;

    char* sffFilename = "stive.sff";

    int computeMode = ComputeGeometry::YAKKA;
    int worldMode = 1;
    int verbose = 0;
    int displayDebug = 0;
    char* libPath = ".";
    int undumpComputeMode = 0;
    int stateMode = 0;

//#define SFFINDER_CALIBRATION_MODE_1
#ifdef SFFINDER_CALIBRATION_MODE_1
  collectMode = 1;
  dumpMode = 1;
  undumpMode = 0;
  dumpNumber = 30;
  dumpSkip = 20;
  noShitDump = 1;
  moveDump = 1;
  PersonPlus::moveThresh = 0.03;
  cerr << "Calibration Mode 1" << endl;
#endif

#ifdef SFFINDER_CALIBRATION_MODE_2
  dumpFilename = dumpFilename1;
  dumpMode = 1;
  undumpMode = 0;
  dumpNumber = 80;
  dumpSkip = 100;
  noShitDump = 1;
  moveDump = 1;
  PersonPlus::moveThresh = 0.01;
  cerr << "Calibration Mode 2: Move Left and Right" << endl;
#endif

#ifdef SFFINDER_CALIBRATION_MODE_3
  dumpFilename = dumpFilename2;
  dumpMode = 1;
  undumpMode = 0;
  dumpNumber = 80;
  dumpSkip = 100;
  noShitDump = 1;
  moveDump = 1;
  PersonPlus::moveThresh = 0.01;
  cerr << "Calibration Mode 3: Move Up and Down" << endl;
#endif
  if( !dumpMode && !serveMode && !displayMode )
    serveMode = 1;

  //////////////////////////////////////////////////////////////////////////////////////////
  SffFile sffFile;
  //    SffinderServer sffinderServer;
  //    PersonViewer personViewer;
  SffinderServer server;
  lffinderClient lffinder;
  rffinderClient rffinder;
  ComputeGeometry computeGeometry;
  PersonPlus personPlus;

  chdir( libPath );
  // sffFile.setPath( libPath );
  if( sffFile.scan( sffFilename ) ){
    cerr << "Unable to open " << sffFilename << endl;
    return;
  }

  computeGeometry.setMode( computeMode );
  computeGeometry.initCalibration( sffFile.stereo_t,
                                  sffFile.stereo_q,
                                  sffFile.stereo_bl );
  computeGeometry.setWorldTransform
  ( qmdVectorRef( 3, sffFile.world_t ),
   qmdMatrixRef( 3, 3, sffFile.world_r ),
   sffFile.world_scale );
   /*
   // ** Set up the viewer
   Widget window;
   if( displayMode )
   {
   window = personViewer.init( argv[0], width, height );
   XtMoveWidget( window, x0, y0 );
   personViewer.setViewTransform( sffFile.view_t,
   sffFile.view_q, 
   sffFile.view_heightAngle );
   personViewer.initCalibration
   ( sffFile.stereo_t[0], sffFile.stereo_t[1], sffFile.stereo_t[2],
   sffFile.stereo_q[0], sffFile.stereo_q[1], sffFile.stereo_q[2],
   sffFile.stereo_q[3], sffFile.stereo_bl );
 
    personViewer.setWorldTransform( sffFile.world_t,
    sffFile.world_r,
    sffFile.world_scale );
    personViewer.initWorld( "world.iv", libPath );
    personViewer.mode = computeMode;
    // personViewer.dumpScene(); exit(0);
    }
  */


  if( serveMode )
  {
    server.init();
    server.start();
  }
  

  
  if( ffinderMode )
  {
    if( lffinder.connect( sffFile.ffinder_left ) ) {
      printf("Failed to connect to lffinder Server.\n");
      exit(1);
    }

    if( rffinder.connect( sffFile.ffinder_right ) ) {
      printf("Failed to connect to rffinder Server.\n");
      exit(1);
    }
  }
  

  if( undumpMode )
  {
    personPlus.readRing( dumpFilename );
  }

  //HowSlow howslow;
  int personState[3];
  for( int i = 0; i < 3; i++ ) personState[i] = personPlus.NoPerson;

  int undumpDir = personPlus.Forward;

  // dumping params
  static int dumpSkipCount = 0;
  static int dumpCount = 0;
  static int lastDumpFrame = 0;

  // ** Main loop
  // for( int frameCount = 0;; frameCount++ )
  for(int frameCount = -1;;  ) {
  
    if(serveMode)
      if(server.quitFlag)
        break;

      if(calibrateFlag )
		 {
       int ncorr;
       float* data; // ncorr * 4
       data = personPlus.getRingCorr( ncorr );
       computeGeometry.calibrate( ncorr, data , "sffinder_camera.out");
        calibrateFlag = 0;
		 }

    if( undumpMode ){
		  if( syncMode )
		     personPlus.undump_force();
		  else
		     personPlus.undump_timed();

      if( stateMode )
        setState( personPlus, computeGeometry, personState );
      if( undumpComputeMode )
        computeGeometry.compute( personPlus.getYArray(),
        personPlus.getValid(),
        personPlus.getTArray(),
        personPlus.getQArray(),
        personPlus.getLArray(),
        personPlus.getTWArray(),
        personPlus.getQWArray(),
        personPlus.getLWArray() );
      frameCount = personPlus.getFrameNumber();
    }
  
    if( ffinderMode ){

      //int oldframe = ffinderClient.callGetCurrent();
      int oldframe = lffinder.lastFrame;
      personPlus.set2( *lffinder.getPerson(),
                       *rffinder.getPerson() );
      oldframe = 0 && (oldframe==lffinder.lastFrame);
  
      if (personPlus.personExists() ){
        if( stateMode )
          setState( personPlus, computeGeometry, personState );
    
        computeGeometry.compute( personPlus.getYArray(),
          personPlus.getValid(),
          personPlus.getTArray(),
          personPlus.getQArray(),
          personPlus.getLArray(),
          personPlus.getTWArray(),
          personPlus.getQWArray(),
          personPlus.getLWArray() );
        computeGeometry.computeQuickPoints( personPlus.getYArray(),
          personPlus.getValid(),
          personPlus.getQPArray() );
    
        //		    static struct timeval tv;
        //		    gettimeofday( &tv );
        qmTime qmtime;
        personPlus.setStamp( frameCount, qmtime.tv.tv_sec, qmtime.tv.tv_usec );
        if( !oldframe )
          frameCount++;

        //cerr << server.homeyPlus.leftHand.x << " " << server.homeyPlus.leftHand.y << endl;
      }else{
        cerr << "No person in scene." << endl;
      }
    }
    personPlus.findHands(); // computes the sffPerson
    server.copy(personPlus.get());

    /*
            sffPerson pn;
        
        pn.frameNumber = frameCount;
        pn.head.x = sin(frameCount/10.0);
        pn.head.y = cos(frameCount/10.0)+1;
        pn.head.z = 0;
        pn.rightHand.x = sin(frameCount/10.0)-1;
        pn.rightHand.y = cos(frameCount/10.0);
        pn.rightHand.z = 0;
        pn.leftHand.x = sin(frameCount/10.0)+1;
        pn.leftHand.y = cos(frameCount/10.0);
        pn.leftHand.z = 0;

        server.copy(pn);
        */

        Sleep(1);

    /*
    if( displayMode )
    {
    personViewer.setExistence( personPlus.personExists() );
    personViewer.set( personPlus.getYArray(),
    personPlus.getValid(),
    personPlus.getTArray(),
    personPlus.getQArray(),
    personPlus.getLArray() );
    personViewer.setHands( personPlus.getHandWhichAxis(),
    personPlus.getHandMinus() );
    personViewer.setFrameNumber( frameCount );
    personViewer.setQuickPoints( personPlus.getQPArray() );
    }
    */

    if( dumpMode )
    {
      // !! dump() wipes out personPlus
      //    so this must go at end -- all done with personPlus!
      if( verbose )
        cerr << "\t" << dumpSkipCount - dumpSkip << endl;
      dumpSkipCount++;
      if( dumpSkipCount > dumpSkip &&
        dumpCount < dumpNumber )
      {
        if( dumpSkipCount == dumpSkip+1 )
          cerr << "COLLECTING FRAMES..."  << endl;
        if( ( !noShitDump || 
         ( frameCount != lastDumpFrame &&
         personPlus.personExists() &&
         personPlus.personFullyValid() ) )
         && ( !moveDump || personPlus.moved2D() ) )
        {
         
          cerr << "COLLECTING FRAMES..." << dumpCount << endl;
     
         personPlus.dump();
         dumpCount++;
         lastDumpFrame = frameCount;
        }
      }
      if( dumpCount >= dumpNumber )
      {
        cerr << "DONE COLLECTING" <<endl;
        calibrateFlag = 1;
        // dumpFile.close();
        if( collectMode )
        {
          //				if( displayMode )
          //				   personViewer.clearMessage();
          dumpMode = 0;
          undumpMode = 1;
          ffinderMode = 0;
        }
        else
        {
          personPlus.writeRing( dumpFilename );
          server.cleanup();
        }
        
      }
    }
  }
}  
