// SffinderClient.h++
// Ali Azarbayejani Mon Jun  3 07:00:16 1996

#ifndef _SffinderClient_H_
#define _SffinderClient_H_

#include <iostream.h>
#include <rpc.h>
#include "sffinder.h"

class SffinderClient
{
    unsigned char * pszUuid;             //= NULL;
  unsigned char pszProtocolSequence[100]; //= "ncacn_np";
  unsigned char * pszNetworkAddress;   //= NULL;
  unsigned char pszEndpoint[100];         //= "\\pipe\\hello";
  unsigned char * pszOptions;          //= NULL;
  unsigned char * pszStringBinding;    //= NULL;
  unsigned char pszString[100];           //= "hello, world";
  unsigned long ulCode;  
  
    sffPerson person;
    sffPersonPlus personPlus;
    int lastFrame;
    enum { GOTNONE, GOTPERSON, GOTPLUS };
    int lastGot;
 public:
	 void quit();
    enum { HEAD, LHAND, RHAND };
    SffinderClient( char* serverHostname = 0 );
    ~SffinderClient();
    int connect( char* serverHostname );

    // nonblocking and blocking call to get entire data structure
    // over here fm server
    // 
    int getPersonFromServer(); // this is obsolete; use getPersonPlus()
    sffPersonPlus* getPersonPlus(); // no matter what
    sffPersonPlus* getNextPersonPlus();
    sffPerson* getNextPerson();
    int getPersonExists(); // non-blocking call to server
    void nextUndump(); // advances single frame in undump mode
#if 0
    sffPersonPlus* getRemotePersonPlus();
    sffPersonPlus* getRemotePersonPlusNext();
    sffPerson* getRemotePerson();
    sffPerson* getRemotePersonNext();
#endif

    // copies data from here to your arrays
    // 
    int getPart( int, float* xyz, float* q = 0, float* l = 0 );
    inline int personExists();

    ostream& print( ostream& );
    void sleep();
    void wakeup();
//     int getRightHand( float* x, float* y, float* z );
//     int getLeftHand( float* x, float* y, float* z );
//     int getHead( float* x, float* y, float* z );
};

inline
int
SffinderClient::personExists()
{ 
    switch( lastGot )
       {
	 case GOTPLUS: return personPlus.personExists;
	 case GOTPERSON: return person.personExists;
	 default: return 0;
       }
}

#endif /* _SffinderClient_H_ */
