// SffinderServer.c++

#include "SffinderServer.h"

sffPerson SffinderServer::homey;
sffPersonPlus SffinderServer::homeyPlus;
int SffinderServer::homeyLock = 0;
int SffinderServer::undumpFlag = 0;
int SffinderServer::sleepFlag = 0;
int SffinderServer::quitFlag = 0;

unsigned char pszProtocolSequence[100] = "ncacn_np";
unsigned char * pszSecurity         = NULL;
unsigned char pszEndpoint[100]         = "\\pipe\\sffinder";
unsigned int    cMinCalls           = 1;
unsigned int    cMaxCalls           = 20;
unsigned int    fDontWait           = FALSE;
 
void
rpc_init(){
    RPC_STATUS status;

    status = RpcServerUseProtseqEp(pszProtocolSequence,
                                   cMaxCalls,
                                   pszEndpoint,
                                   pszSecurity);  // Security descriptor
    printf("RpcServerUseProtseqEp returned 0x%x\n", status);
    if (status) {
        exit(status);
    }

    status = RpcServerRegisterIf(sffinder_v1_0_s_ifspec,  // interface to register
                                 NULL,   // MgrTypeUuid
                                 NULL);  // MgrEpv; null means use default
    printf("RpcServerRegisterIf returned 0x%x\n", status);
    if (status) {
        exit(status);
    }

}

void
service_rpc()
{
  RPC_STATUS status;
  printf("Calling RpcServerListen\n");
  status = RpcServerListen(cMinCalls,
                  cMaxCalls,
                  fDontWait);
  printf("RpcServerListen returned: 0x%x\n", status);
  printf("Calling RpcMgmtWaitServerListen\n");
  RpcMgmtWaitServerListen();  // wait operation
  printf("RpcMgmtWaitServerListen returned: 0x%x\n", status);
}

DWORD WINAPI
serverThread( void * )
{
  rpc_init();
  while( !SffinderServer::quitFlag )
     service_rpc();

  return 0;
}

void
SffinderServer::cleanup()
{
  //RpcMgmtStopServerListening(NULL);
  quitFlag = 1;
}

void SffinderServer::start()
{
  unsigned long thread_id;
  CreateThread(NULL,NULL,serverThread,NULL,NULL,&thread_id);
}

// ------------------------------------------------
// Server-side stubs for the sffinder 

int 
sffquit()
{
    static int retval = 0;
    printf("sffquit called\n");
    //RpcMgmtStopServerListening(NULL);
    SffinderServer::quitFlag = 1;
    //Sleep(0);
    //exit(1);
    return retval;
}

sffPerson
sffgetperson()
{
    static sffPerson localHomey;
    while( SffinderServer::homeyLock )
       Sleep(0);
    SffinderServer::homeyLock = 1;
    localHomey = SffinderServer::homey;
    SffinderServer::homeyLock = 0;
    return localHomey;
}

sffPersonPlus
sffgetpersonplus()
{
    static sffPersonPlus localHomey;
    while( SffinderServer::homeyLock )
       Sleep(0);
    SffinderServer::homeyLock = 1;
    localHomey = SffinderServer::homeyPlus;
    SffinderServer::homeyLock = 0;
    return localHomey;
}

sffPersonPlus 
sffgetnextpersonplus( int tlast )
{
    static sffPersonPlus localHomeyPlus;
    // while( SffinderServer::homeyPlus.frameNumber <= *tlast )
    while( SffinderServer::homeyPlus.frameNumber == tlast )
       Sleep( 1 );
    while( SffinderServer::homeyLock )
       Sleep( 0 );
    SffinderServer::homeyLock = 1;
    localHomeyPlus = SffinderServer::homeyPlus;
    SffinderServer::homeyLock = 0;
    return localHomeyPlus;
}

sffPerson
sffgetnextperson( int tlast)
{
    static sffPerson localHomey;
    //while( SffinderServer::homey.frameNumber == tlast )
    //   Sleep(2);
    //while( SffinderServer::homeyLock )
    //   Sleep( 0 );
    SffinderServer::homeyLock = 1;
    localHomey = SffinderServer::homey;
    SffinderServer::homeyLock = 0;
    return localHomey;
}

int
sffundumpnext()
{
    static int rvalue = 0;
    SffinderServer::undumpFlag = 1;
    return rvalue;
}

int
sffgetpersonexists()
{
    static int rvalue = 0;
    rvalue = SffinderServer::homeyPlus.personExists;
    return rvalue;
}

SffinderServer::SffinderServer()
{
    init();
    quitFlag = 0;
}

void
SffinderServer::init()
{
    homey.leftHand.valid = 0;
    homey.rightHand.valid = 0;
    homey.head.valid = 0;
    homeyPlus.head.valid = 0;
    homeyPlus.leftHand.valid = 0;
    homeyPlus.rightHand.valid = 0;
}

void
SffinderServer::copy( const sffPersonPlus& spp )
{
    while( homeyLock )
       Sleep( 0 );
    homeyLock = 1;
    homeyPlus = spp;
    homeyLock = 0;
}

void
SffinderServer::copy( const sffPerson& spp )
{
    while( homeyLock )
       Sleep( 0 );
    homeyLock = 1;
    homey = spp;
    homeyLock = 0;
}

void
sffsleep()
{
    SffinderServer::sleepFlag = 1;
}
    
void
sffwakeup()
{

}


//////////////////////////////////////////////////////////////////////////////

void SffinderServer::quit()
{
  sffquit();
}
