// vliRGBImage.c++

#include "vliRGBImage.h"

vliRGBImage::vliRGBImage( int w, int h )
  : vliRGBImageRef( w, h, 0 ),
    allocArray( new byte[ w * h * vliRGBBytesPerPixel ] )
{
    data = allocArray;
}

vliRGBImage::vliRGBImage( const vliRGBImage& src )
  : vliRGBImageRef( 0, 0, 0 ),
    allocArray( 0 )
{
    set( src );
}

vliRGBImage::vliRGBImage( const vliRGBImageRef& src )
  : vliRGBImageRef( 0, 0, 0 ),
    allocArray( 0 )
{
    set( src );
}

void
vliRGBImage::set( const vliRGBImageRef& src )
{
    if( allocArray && pixelCount < src.getPixelCount() )
       { 
	   delete [] allocArray;
	   allocArray = 0;
       }
    if( !allocArray )
       allocArray = new byte[ src.getPixelCount() * vliRGBBytesPerPixel ];
    pixelCount = src.getPixelCount();
    width = src.getWidth();
    bytesPerPixel = vliRGBBytesPerPixel;
    data = allocArray;
    copy( src );
}

void
vliRGBImage::set( int w, int h )
{
    if( allocArray && pixelCount < w*h )
       { 
	   delete [] allocArray;
	   allocArray = 0;
       }
    if( !allocArray )
       allocArray = new byte[ w * h * vliRGBBytesPerPixel ];
    pixelCount = w*h;
    width = w;
    bytesPerPixel = vliRGBBytesPerPixel;
    data = allocArray;
}

